! GiD postprocess t@Co͂̂߂̃W[D
! {W[ł́CADT ̊TOSȂ΂肩Co͂GiD pR}h́C
! element_class  wrt ̒gĂ܂ĂEEEEL^iCEEE

MODULE GiD_IO_module

   USE constants
   USE material_class
   USE element_class
   IMPLICIT none
   PRIVATE

   PUBLIC init_GiD_postfile
   PUBLIC wrt_GiD_postfile

CONTAINS

   SUBROUTINE init_GiD_postfile ( ID, X_DB, elm_DB )

      CHARACTER(*),INTENT(in   ) :: ID
      REAL(DP),    INTENT(in   ) :: X_DB(:,:)
      TYPE(elm_c), INTENT(in   ) :: elm_DB(:)

      INTEGER :: uid = 23
      INTEGER :: nodes(nnodee)
      INTEGER :: mat
      INTEGER :: i, k

      ! *.post.mshiIvVit@Cj̍쐬
      OPEN(uid, file=TRIM(ID)//'.post.msh')

#ifdef TWO
      WRITE(uid,*)'MESH "my_mesh" Dimension 2 Elemtype Quadrilateral Nnode 4'
#else
      WRITE(uid,*)'MESH "my_mesh" Dimension 3 Elemtype Hexahedra Nnode 8'
#endif
      WRITE(uid,*)'# color 127 127 127'

      WRITE(uid,*)''
      WRITE(uid,*)'Coordinates'
#ifdef TWO
      WRITE(uid,*)'# node Num.  coordinate_X   coordinate_Y'
#else
      WRITE(uid,*)'# node Num.  coordinate_X   coordinate_Y   coordinate_Z'
#endif

      DO i = 1, SIZE(X_DB, DIM=2)
         WRITE( uid, '(I7, 3ES15.7)' ) i, X_DB (:,i)
      END DO
      WRITE(uid,*)'end coordinates'

      WRITE(uid,*)''
      WRITE(uid,*)'Elements'
#ifdef TWO
      WRITE(uid,*)'# element Num.  node_1   node_2    node_3    node_4    material_Num'
#else
      WRITE(uid,*)'# element Num.  node_1   ....   node_8   material_Num'
#endif
      DO k = 1, SIZE(elm_DB)
         nodes(:) = get_nodeNo(elm_DB(k))
         mat      = get_matNo (elm_DB(k))
         WRITE(uid,'(I7,100I7)') k, nodes(:), mat
      END DO
      WRITE(uid,*)'end elements'

      CLOSE(uid)

      ! *.post.res ̏
      OPEN(uid, file=TRIM(ID)//'.post.res')
      WRITE(uid,*)'GiD Post Results File 1.0'

      WRITE(uid,*)''
#ifdef TWO
      WRITE(uid,*)'GaussPoints "GP"  Elemtype Quadrilateral'
      WRITE(uid,*)'  Number of Gauss Points: 4'
#else
      WRITE(uid,*)'GaussPoints "GP"  Elemtype Hexahedra'
      WRITE(uid,*)'  Number of Gauss Points: 8'
#endif
      WRITE(uid,*)'  Natural Coordinates: Internal'
      WRITE(uid,*)'End GaussPoints'

      CLOSE(uid)

   END SUBROUTINE init_GiD_postfile


   SUBROUTINE wrt_GiD_postfile  ( ID   , step , X_DB , elm_DB, mat_DB, &
                                & nDOF1, nDOF2, U    , Fin   , Fex   , &
                                & node2DOFg_DB, edge2DOFg_DB , Vel     )

      CHARACTER(*),      INTENT(in   ) :: ID
      INTEGER,           INTENT(in   ) :: step
      REAL(DP),          INTENT(in   ) :: X_DB(:,:)
      TYPE(elm_c),       INTENT(in   ) :: elm_DB(:)
      TYPE(mat_c),       INTENT(in   ) :: mat_DB(:)
      INTEGER,           INTENT(in   ) :: nDOF1
      INTEGER,           INTENT(in   ) :: nDOF2
      REAL(DP),          INTENT(in   ) :: U  (nDOF1:nDOF2)
      REAL(DP),          INTENT(in   ) :: Fin(nDOF1:nDOF2)
      REAL(DP),          INTENT(in   ) :: Fex(nDOF1:nDOF2)
      INTEGER,           INTENT(in   ) :: node2DOFg_DB(:,:) !( nDOFn , nnode )
      INTEGER, OPTIONAL, INTENT(in   ) :: edge2DOFg_DB(:)   !( nedge )
      REAL(DP),OPTIONAL, INTENT(in   ) :: Vel(nDOF1:nDOF2)  ! xi_~[j

      INTEGER :: uid = 23
      INTEGER :: DOFe2g(nDOFe)
      REAL(DP):: Ue    (nDOFe)
      REAL(DP):: Un(ndim), Finn(ndim)
      INTEGER :: i, k

      OPEN(uid, file=TRIM(ID)//'.post.res',position="append")

      WRITE(uid,*)''
      WRITE(uid,'(A,I9,A)')'ResultGroup "Load_Analysis" ',step, ' OnNodes'
#ifdef TWO
      WRITE(uid,*)'ResultDescription "Displacement"   Vector:2'
      WRITE(uid,*)'ResultDescription "Iternal Force"  Vector:2'
#else
      WRITE(uid,*)'ResultDescription "Displacement"   Vector:3'
      WRITE(uid,*)'ResultDescription "Iternal Force"  Vector:3'
#endif

      WRITE(uid,*)''
      WRITE(uid,*)'Values'
      DO i = 1, SIZE(node2DOFg_DB, DIM=2)
        Un  (:) = U  (node2DOFg_DB(:,i))
        Finn(:) = Fin(node2DOFg_DB(:,i))
        WRITE(uid ,'(I7,6ES15.7)') i, Un,  Finn
      END DO
      WRITE(uid,*)'End Values'

      WRITE(uid,*)''
      WRITE(uid,'(A,I9,A)')'ResultGroup "Load_Analysis" ',step, ' OnGaussPoints "GP"'
#ifdef TWO
      WRITE(uid,*)'ResultDescription "strain"       Matrix:3' !  element_class ŏׂD
      WRITE(uid,*)'ResultDescription "stress"       Matrix:3'
#else
      WRITE(uid,*)'ResultDescription "strain"       Matrix:6' !  element_class ŏׂD
      WRITE(uid,*)'ResultDescription "stress"       Matrix:6'
#endif

      WRITE(uid,*)''
      WRITE(uid,*)'Values'
      DO k = 1, SIZE(elm_DB)
         DOFe2g(:) = get_DOFg ( elm_DB(k), node2DOFg_DB, edge2DOFg_DB )
         Ue(:)     = U(DOFe2g(:))
         WRITE(uid,'(I7)',advance='No') k
         CALL wrt ( elm_DB(k), X_DB, mat_DB, Ue, uid )
      END DO
      WRITE(uid,*)'End Values'

      CLOSE(uid)

   END SUBROUTINE wrt_GiD_postfile

END MODULE GiD_IO_module
