!*****************************************************************************************
!***    A1 Ax = b Ot̋z@nŉ߂̃[`W            ***
!***                  gpf[^\Fuksi[(Compressed Row Storage, CRS)`v  ***
!*****************************************************************************************

! ӁjILUO vvZbTʎq SYM_MTX Y ́COpenMP񉻂ɔΉ

MODULE PCG_CRS_module

   USE constants
   USE sort_and_search_module, ONLY: binary_search
   USE matvec_CRS_module
   USE timer_class
   IMPLICIT none
   PRIVATE

   !------ [U[ݒ荀 --------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   CHARACTER(2) :: SOLVER   = "CG"           ! "CG" or "MR"TR
   CHARACTER(2) :: PRECOND  = "D"            ! "N"one, "D"iag_scaling, "I"LU(0)
   REAL         :: TOL      = 1.0e-6         ! 
   INTEGER      :: MAX_ITER = 2000           ! ł؂蔽
   INTEGER      :: MONITOR  =  100           ! this%is_first C󋵂̉ʏo͕px
   !<<<<<<<<<<<<<<<<<<<<<<<<---------------------------- ݒ荀 --------

   TYPE, PUBLIC :: PCG_M_handle
      PRIVATE
      REAL(DP), ALLOCATABLE :: M(:)          ! (n) for "D"iag, (nnz) for "I"LU  Oq
      INTEGER,  ALLOCATABLE :: ind_D(:)      ! (n) Ίp̊i[AhXiƌvZupj
      REAL                  :: FLOPs         ! 1񂠂̕_vZ
      LOGICAL               :: is_first      ! M(:) XVꂽ̂ݐ^
   END TYPE PCG_M_handle

   ! ƔzȋasŋLDȂ̂ŏI͂Ȃj
   REAL(DP), ALLOCATABLE :: p(:), r(:)                   ! CG & MRTR ŋL
   REAL(DP), ALLOCATABLE :: qz(:)                        ! CGp
   REAL(DP), ALLOCATABLE :: u(:), v(:), w(:), y(:), z(:) ! MRTRp
   INTEGER               :: MAX_n = -1                   ! őTCY

   ! <<< ֐|C^ apply_M ^̒` >>>
   ABSTRACT INTERFACE                        ! F2003
      SUBROUTINE apply_M ( M , DOF, ind, ind_D,  r,  z,  n   )
         !
         ! c r(:) ɑOq M p̂Cz(:) ɕԂDz = M^{-1} r
         ! ȂC֐|C^we֐ł͕svȈ̂ŗvӁD
         ! i֐|C^̎dlČ^ƕт͈vĂȂ΂ȂȂj
         !
         ! ⑫j́CœKւ̕SyFortran77`CȂ킿AȂƂ
         !       OƂ`󖾎z(Fa(n)) ƌ`󉼒ziFa(*)jƂĂ
         !       íCK؂ɍœKł΁C`󖾎zƌ`pziFa(:)C
         !         zLqqn)̍́CXgCh1̏ꍇɊFɂȂDj
         !       ̃XgCh1łȂꍇɂ́C a(n), a(*) ꍇɂ
         !       KRIɃt̂ŗvӁI
         !
         USE constants
         REAL(DP), INTENT(in   ) :: M  (*)   ! (n) for "D"iag, (nnz) for "I"LU  nnz=ind(n+1)-1
         INTEGER,  INTENT(in   ) :: DOF(*)   ! (nnz) CRS`ɂ̑SDOFԍQ
         INTEGER,  INTENT(in   ) :: ind(n+1) ! ind  (i): isڐDOF(:)ł̊i[Jnʒu
         INTEGER,  INTENT(in   ) :: ind_D(n) ! ind_D(i): isڑΊp DOF(:)ł̊i[ʒu
         REAL(DP), INTENT(in   ) :: r  (n)   ! c
         REAL(DP), INTENT(out  ) :: z  (n)
         INTEGER,  INTENT(in   ) :: n
      END SUBROUTINE apply_M
   END INTERFACE
   PROCEDURE(apply_M), POINTER :: p_apply_M  ! F2003
   ! ֐|C^ apply_M ^̕[`̂CۂɎgp̂
   ! RpCɐÓIɉĂ܂̂ŁC̈ʒuł̐錾ŖȂ

   PUBLIC :: init_PCG_CRS
   PUBLIC :: set_M_PCG_CRS
   PUBLIC :: solve_PCG_CRS
   PUBLIC :: final_PCG_CRS

CONTAINS
!
!*****************************************************************************************
   SUBROUTINE init_PCG_CRS ( this ,a   ,DOF ,ind )

      TYPE(PCG_M_handle), INTENT(inout) :: this
      REAL(DP),           INTENT(in   ) :: a  (:) ! (nnz)
      INTEGER,            INTENT(in   ) :: DOF(:) ! (nnz)
      INTEGER,            INTENT(in   ) :: ind(:) ! (n+1)

      INTEGER :: n, nnz
      INTEGER :: i, loc
      LOGICAL :: exist

      CALL final_PCG_CRS ( this )

      n   = SIZE(ind) -1
      nnz = SIZE(DOF)    ! ʈāF nnz = ind(n+1) -1 

      IF ( MAX_n < n ) THEN    !̑asԂŋLƔźCőTCYŊt
         IF ( ALLOCATED(p) ) DEALLOCATE( p    ,r    )
                               ALLOCATE( p(n) ,r(n) )
         IF ( ALLOCATED(qz)) DEALLOCATE( qz   )
         IF ( SOLVER == "CG" ) ALLOCATE( qz(n))
         IF ( ALLOCATED(u) ) DEALLOCATE( u    ,v    ,w    ,y    ,z    )
         IF ( SOLVER == "MR" ) ALLOCATE( u(n) ,v(n) ,w(n) ,y(n) ,z(n) )
         MAX_n = n
      END IF

      ! Ίp̊i[ʒuTCthis%ind_D(:) Ɋi[iDiag  ILU ɂƕ֗
      ALLOCATE ( this%ind_D( n )  )
      !$OMP PARALLEL DO PRIVATE ( loc, exist )
      DO i = 1, n
#ifdef SYM_MTX
         this%ind_D(i) = ind(i)
#else
         loc = binary_search ( i, DOF( ind(i) : ind(i+1)-1 ), exist )
         IF ( .NOT. exist ) STOP "init_PCG: asɑΊpȂ"
         this%ind_D(i) = ind(i) -1 + loc
#endif
      END DO

      SELECT CASE ( PRECOND )

         CASE ( "N" )                               ! "N"o preconditioner
            WRITE(*,*) "̑OFȂ"
            ALLOCATE( this%M( 0   ) )
            p_apply_M => apply_No_M_F77
            this%FLOPs = 0

         CASE ( "D" )                               ! "D"iagonal scaling
            WRITE(*,*) "̑OFΊpXP[O"
            ALLOCATE( this%M( n   ) )
            p_apply_M => apply_D_scaling_F77
            this%FLOPs = 2*nnz

         CASE ( "I" )                               ! "I"LU
            WRITE(*,*) "̑OFILU0iOpenMP񉻂ɔΉj"
            ALLOCATE( this%M( nnz ) )
            p_apply_M => apply_ILU_F77
            this%FLOPs = 0

         CASE default
            STOP "init_PCG_CRS G[F̂ȂO"

      END SELECT

   END SUBROUTINE init_PCG_CRS
!
!*****************************************************************************************
   SUBROUTINE set_M_PCG_CRS ( this ,a   ,DOF ,ind )
      TYPE(PCG_M_handle), INTENT(inout) :: this
      REAL(DP),           INTENT(in   ) :: a  (:) ! (nnz)
      INTEGER,            INTENT(in   ) :: DOF(:) ! (nnz)
      INTEGER,            INTENT(in   ) :: ind(:) ! (n+1)
      INTEGER :: n
      n = SIZE(ind) -1
      SELECT CASE ( PRECOND )
         CASE ( "D" )                               ! "D"iagonal scaling
            CALL set_D_F77   ( a, this%M,           this%ind_D, n )
         CASE ( "I" )                               ! "I"LU
            CALL set_ILU_F77 ( a, this%M, DOF, ind, this%ind_D, n )
      END SELECT
      this%is_first = .TRUE.
   END SUBROUTINE set_M_PCG_CRS


   SUBROUTINE final_PCG_CRS ( this )
      TYPE(PCG_M_handle), INTENT(inout) :: this
     IF ( ALLOCATED( this%M     ) ) DEALLOCATE( this%M     )
     IF ( ALLOCATED( this%ind_D ) ) DEALLOCATE( this%ind_D )
   END SUBROUTINE final_PCG_CRS

!*****************************************************************************************
   ! <<< ֐|C^ apply_M ^̃[` >>>
   SUBROUTINE apply_No_M_F77 ( M, DOF, ind, ind_D, r, z, n )
      REAL(DP), INTENT(in   ) :: M  (*)   ! gp
      INTEGER,  INTENT(in   ) :: DOF(*)   !   V
      INTEGER,  INTENT(in   ) :: ind(n+1) !   V
      INTEGER,  INTENT(in   ) :: ind_D(n) !   V
      REAL(DP), INTENT(in   ) :: r  (n)
      REAL(DP), INTENT(out  ) :: z  (n)
      INTEGER,  INTENT(in   ) :: n
      INTEGER :: i
      !$OMP PARALLEL DO
      DO i = 1, n
         z(i) = r(i)
      END DO
   END SUBROUTINE apply_No_M_F77

!***************************
   SUBROUTINE set_D_F77 ( a, inv_D, ind_D, n )
      ! CRS`̑as A CΊpXP[Op̑Oq M = diag(A) 쐬
      REAL(DP), INTENT(in   ) :: a(*)     ! (nnz)  nnz = ind(n+1) -1
      REAL(DP), INTENT(out  ) :: inv_D(n) ! M ɂ diag(A) łȂ diag(A)^(-1) i[
      INTEGER,  INTENT(in   ) :: ind_D(n) 
      INTEGER,  INTENT(in   ) :: n
      INTEGER :: i, p
      !$OMP PARALLEL DO PRIVATE ( p )
      DO i = 1, n
         p = ind_D(i)
         inv_D(i) = 1.0_DP / a(p)
      END DO
   END SUBROUTINE set_D_F77

   ! <<< ֐|C^ apply_M ^̃[` >>>
   SUBROUTINE apply_D_scaling_F77 ( inv_D, DOF, ind, ind_D, r, z, n )
      ! ΊpXP[OOq M = diag(A)  r(:) ɍpāCz(:) = M^{-1} r(:) Ԃ
      REAL(DP), INTENT(in   ) :: inv_D(*) ! (n)   M = diag(A) C̋tŋL
      INTEGER,  INTENT(in   ) :: DOF  (*) ! gp
      INTEGER,  INTENT(in   ) :: ind(n+1) !   V
      INTEGER,  INTENT(in   ) :: ind_D(n) !   V
      REAL(DP), INTENT(in   ) :: r  (n)
      REAL(DP), INTENT(out  ) :: z  (n)
      INTEGER,  INTENT(in   ) :: n
      INTEGER :: i
!      !$OMP PARALLEL DO
      DO i = 1, n
         z(i) = inv_D(i) * r(i)
      END DO
   END SUBROUTINE apply_D_scaling_F77
!
!***************************
   SUBROUTINE set_ILU_F77 ( a, lu, DOF, ind, ind_D, n, sigma_ )
      ! CRS`̑as A CsSLUp̑Oq M = LU 쐬isj
      ! is A Ώ̂̏ꍇCILU(0) ƕsSRXL[ IC(0) ͓j
      REAL(DP), INTENT(in   ) :: a  (*)   ! (nnz)  nnz = ind(n+1) -1
      REAL(DP), INTENT(out  ) :: lu (*)   ! (nnz) M ɂ́CsSLǓʂi[
      INTEGER,  INTENT(in   ) :: DOF(*)   ! (nnz)
      INTEGER,  INTENT(in   ) :: ind(n+1)
      INTEGER,  INTENT(in   ) :: ind_D(n)
      INTEGER,  INTENT(in   ) :: n
      REAL(DP), OPTIONAL, INTENT(in   ) :: sigma_  ! AΏ́CȂ킿IC(0)̂Ƃ̉W

      ! ʂɁCILU A = LU - R ƕ\LCM = LU ƂDɁCas A ̔[\
      ! Op͂̂܂ L ɁCOp͂̂܂ U ɔfDRC[\̐ۂ
      ! Ȃ R = 0CȂ킿ʏ̊SLUƂȂD
      ! QƕFYousef Saad, Iterative methods for sparse linear systems, SIAM, 1996
      !           http://www-users.cs.umn.edu/~saad/books.html
      !
      ! ! ܂́Ct}gNXisj\Lɂ  IKJ   inplace ^ S LU 
      ! l => a;  u => a                 ! l  u  a ̕ʖɉ߂Ȃ LUߒ𗝉Ղ
      ! !    ___k_________j__           ! 邽߁Ca ͕O`𒆂Cl  u ͕D
      ! !   |   :    :              
      ! !  k|===@******** u(k,k+1:n)
      ! !   | u(k,k) :              
      ! !  i|===@oooo*ooo a(i,k+1:n)
      ! !   | l(i,k)                
      !
      ! DO i = 2, n
      !    DO k = 1, i-1
      !       l(i,k) = a(i,k) / u(k,k)  ! a(i,k)  l(i,k) ƂȂĊ
      !       FORALL ( j = k+1: n )
      !          a(i,j) = a(i,j) - l(i,k)*u(k,j) ! u(k,:) ̐`iW l(i,k) j a(i,:) Ɋi[
      !       END FORALL
      !    END DO                       !  k [v𔲂ƁCa(i,i:n)  u(i,i:n) ƂȂĊ
      !    ! ȍ~̕ߒł́Cl(i,1:i-1) ͎QƂ炳ꂸCu(i,i:n) ͎QƂ̂݁D
      !    ! ȂCu(1,:) QƂɂ́Ci=2,n ł͂Ȃ i=1,n ƂKvD
      ! END DO
      !
      ! CRS`ɑ΂ ILU(0) ł́CL ϐ j Ɋւ
      ! a(i,j) = a(i,j) - l(i,k)*u(k,j) ̉ŹCa(i,k+1:n), u(k,k+1:n) Ƃ ̑as\
      ! ̔[vf̈ʒuî"0"xjł̂ݎs邱ƂƂȂDႦ΁Ck=2 Ƃ
      !
      !              k+1         C[W          n              CRS L`ɂ
      !        DOF #  3___4___5___6___7___8___9___10_
      ! u(k,k+1:n) = |_0_|_x_|_0_|_x_|_x_|_x_|_0_|_x_|  DOF(ind_D(k)+1:ind(k+1)-1) = 4, 6, 7, 8,10
      !               _______________________________
      ! a(i,k+1:n) = |_x_|_x_|_0_|_0_|_x_|_0_|_x_|_0_|  DOF(ind_D(i)+1:ind(i+1)-1) = 3, 4, 7,10
      !
      ! ̂悤ȏꍇCj=4, 7 ̂݁CȂ킿 DOF(ind_D(k)+1:ind(k+1)-1)  DOF(ind_D(i)+1:ind(i+1)-1) 
      ! ̐ϏWɂĂ̂ݎsDDOF(ind(i):ind(i+1)-1) ͏ς݂ł邽߁C̐ϏW
      ! óC2nf[^̓˂킹}[WƓl̃ASYŋLqłD

      INTEGER  :: nnz
      INTEGER  :: p, i, k
      INTEGER  :: pkk,      pkj   ! CRS pointer to (k,j)-th entry of full matrix
      INTEGER  :: pik, pii, pij   ! i > k
      INTEGER  ::            kj   ! (k,j)̂ DOFԍ j
      INTEGER  ::            ij   ! (i,j)  V       V      i

#ifdef SYM_MTX
      STOP "IC(0) ͖"
#endif
!
      nnz = ind(n+1) -1
      DO p = 1, nnz
         lu(p) = a(p)
      END DO
      ! AΏ̂̂ƂCILU(0)  ICCG(0) ɂȂCW  >0 lD  A = A +  diag(A)
      IF ( PRESENT(sigma_) ) THEN
         IF ( sigma_ > 0.0_DP ) THEN
            !$OMP PARALLEL DO PRIVATE ( pii )
            DO i = 1, n
               pii = ind_D(i)
               lu(pii) = ( 1.0_DP + sigma_ ) * lu(pii)
            END DO
         END IF
      END IF

      DO i = 1, n                                         ! u(1,1) ւ̏Cs i=2,n ƂȂ
         DO pik = ind(i) , ind_D(i) -1
            k   = DOF(pik)
            pkk = ind_D(k)
            ! l(i,k) = a(i,k) / u(k,k) ̌vZDCu(k,k) (i>k)  tŋLĂ邱Ƃɒ
            lu(pik) = lu(pik) * lu(pkk)

            ! ȉł CRS `ɂċʂ  DOFԍ j ꍇTāC
            ! ̂Ƃ̂ a(i,j) = a(i,j) - l(i,k)*u(k,j) ۂɎsD
            pij = pik +1
            pkj = pkk +1
            DO
               IF (      pkj >= ind(k+1) &
                  & .OR. pij >= ind(i+1) ) EXIT
               kj = DOF(pkj)
               ij = DOF(pij)
               IF      ( kj >  ij ) THEN
                  pij = pij +1
               ELSE IF ( kj <  ij ) THEN
                  pkj = pkj +1
               ELSE  ! ( kj =  ij ) THEN          ! ʂ j 𔭌!
                  lu(pij) = lu(pij) - lu(pik) * lu(pkj)
                  pij = pij +1                  ! ij, kj ƂɏdȂ߁C
                  pkj = pkj +1                  ! ͕KႤ DOF ԍłD
               END IF
            END DO
         END DO                       !  k [v𔲂ƁCa(i,i:n)  u(i,i:n) ƂȂĊ
         pii = ind_D(i)
         ! LU  U ̑Ίpɂ鏜Z邽߂ɁC炩ߋtŋLĂC
         ! Ɋ|ZƂł悤ɂĂ
         IF ( ABS( lu(pii) ) < EPSILON(lu) ) THEN
            WRITE(*,"('ӁFILỦߒőΊp臒lȉƂȂI',&
                     &'iF',I6,'  ,Ίp̈ʒuF',I6',  ̒lF',ES10.1e3,' j')") &
                     &              n,                     i,             lu(pii)
         END IF
         lu(pii) = 1.0_DP / lu(pii)
      END DO

   END SUBROUTINE set_ILU_F77
!
   ! <<< ֐|C^ apply_M ^̃[` >>>
   SUBROUTINE apply_ILU_F77 ( lu, DOF, ind, ind_D,  r,  z, n  )
      ! sSLUOq M = LU  r(:) ɍpāCz(:) = M^{-1} r(:) Ԃisj
      REAL(DP), INTENT(in   ) :: lu (*)      ! (nnz) sSLU
      INTEGER,  INTENT(in   ) :: DOF(*)      ! (nnz)
      INTEGER,  INTENT(in   ) :: ind(n+1)
      INTEGER,  INTENT(in   ) :: ind_D(n)
      REAL(DP), INTENT(in   ) :: r  (n)
      REAL(DP), INTENT(out  ) :: z  (n)
      INTEGER,  INTENT(in   ) :: n

      INTEGER  :: i, j, p
      REAL(DP) :: inv_uii
      REAL(DP) :: s

      ! ⑫jsSLUOiޑʓIɕ񉻂ɂ́Cȉ̕QlɂȂ
      !       uOpenMPɂvO~O(I)`(III)v by 
      !       http://www-solid.eps.s.u-tokyo.ac.jp/~nakajima/tutorial/sr11k/index.html

      ! Oi
      DO i = 1, n
       ! z(i) = r(i) - DOT_PRODUCT ( lu    (ind(i): ind_D(i)-1) , &
       !                           & z (DOF(ind(i): ind_D(i)-1))  )
       ! ͎̂悤ɂD
         s = r(i)
         DO p = ind(i) , ind_D(i) -1
            j = DOF(p)
            s = s - lu(p)*z(j)
         END DO
         z(i) = s
      END DO

      ! ޑ
      DO i = n, 1, -1
         inv_uii = lu(ind_D(i))              ! u(i,i)  tŋLĂ邱Ƃɒ
       ! z(i) = z(i) - DOT_PRODUCT ( lu    (ind_D(i)+1: ind(i+1)-1) , &
       !                           & z (DOF(ind_D(i)+1: ind(i+1)-1))  )
       ! ͎̂悤ɂD
         s = z(i)
         DO p = ind_D(i)+1, ind(i+1)-1
            j = DOF(p)
            s = s - lu(p)*z(j)
         END DO
         z(i) = s * inv_uii
      END DO

   END SUBROUTINE apply_ILU_F77
!
!*****************************************************************************************
   SUBROUTINE solve_PCG_CRS ( this, a, DOF, ind, msglvl, b, x  )

      TYPE(PCG_M_handle), INTENT(inout) :: this
      REAL(DP),           INTENT(in   ) :: a  (:) ! (nnz) 
      INTEGER,            INTENT(in   ) :: DOF(:) ! (nnz) 
      INTEGER,            INTENT(in   ) :: ind(:) ! (n+1)
      INTEGER,            INTENT(in   ) :: msglvl ! 0: bZ[WȂ, 1 bZ[W
      REAL(DP),           INTENT(in   ) :: b(:)
      REAL(DP),           INTENT(inout) :: x(:)

      INTEGER :: n, nnz
      INTEGER :: iter                       ! ɗv
      TYPE(timer_c) :: timer
      REAL(DP)      :: wtime

      IF ( .NOT. ALLOCATED(p) ) STOP "G[Fsolve_PCG_CRS: v"

      n   = SIZE(ind) -1
      nnz = SIZE(DOF)
      IF ( SIZE(b)/=n .OR. SIZE(x)/=n ) &
      & STOP "G[Fsolve_PCG_CRS: asƐxNg̑傫vȂ"

      CALL tic( timer )
      SELECT CASE ( SOLVER )
         CASE ( "CG" )  ! lsi_Iɂ͔lOKj
            CALL PCG_F77  (      a,   DOF,   ind, this%ind_D,                        &
                          & this%M,     b,     x,          n,    iter, this%is_first )
            this%FLOPs =   this%FLOPs     & ! O
                       & + (   nnz*2 + n  & ! q = Ap
                       &     + 3*(n*2)    & ! 
                       &     + 3*(n*2)   )  ! xNgm̉Z
         CASE ( "MR" )  ! Ώ̍s񁕔lsilsɑ΂ Soft Landing j
            CALL MRTR_F77 (      a,   DOF,   ind, this%ind_D,                        &
                          & this%M,     b,     x,          n,    iter, this%is_first )
            this%FLOPs =   this%FLOPs     & ! O
                       & + (   nnz*2 + n  & ! q = Ap
                       &     + 4*(n*2)    & ! 
                       &     + 6*(n*2)   )  ! xNgm̉Z
         CASE default
            STOP "G[FĂȂ@"
      END SELECT
      wtime = toc( timer )

      IF ( msglvl == 1 ) THEN
         WRITE (*,'(":",I5," ,FLOPS:",F9.2,"G, oߎ:",F7.2,"b")') &
            & iter, this%FLOPs * iter / wtime * 1.0e-9, wtime
      END IF

   END SUBROUTINE solve_PCG_CRS

!
   SUBROUTINE PCG_F77  (       a,     DOF,     ind,   ind_D,                   &
                       &       M,       b,       x,       n,    iter, is_first )

      ! CRSL`̑as A ɑ΂ Ax=b Otz@ɂ private[`
      ! i A ͐ls񂠂邢͔lD҂̏ꍇCɔÛ MRTR̕x^[j

      REAL(DP),   INTENT(in   ) :: a  (*)  ! (nnz)
      INTEGER,    INTENT(in   ) :: DOF(*)  ! (nnz)
      INTEGER,    INTENT(in   ) :: ind(n+1)! (n+1)
      INTEGER,    INTENT(in   ) :: ind_D(n)! (n)
      REAL(DP),   INTENT(in   ) :: M  (*)  ! (0, n, or nnz )
      REAL(DP),   INTENT(in   ) :: b  (n)  ! (n)
      REAL(DP),   INTENT(inout) :: x  (n)  ! (n)
      INTEGER,    INTENT(in   ) :: n
      INTEGER,    INTENT(out  ) :: iter    ! 
      LOGICAL,    INTENT(in   ) :: is_first

      INTEGER  :: i
      REAL(DP) :: b_norm, r_norm
      REAL(DP) :: pq, zr, zr_new   ! ϒl
      REAL(DP) :: alpha, beta      ! _k, _k
      REAL     :: err

      b_norm = norm (b, n )
      IF ( (b_norm*TOL)**2 <= TINY(0.0_DP) ) THEN  ! I b_norm == 0.0_DP
         iter = 0
         x(:) = 0.0_DP
         RETURN
      END IF

      ! PCG@̏ݒ
      CALL matvec_F77 ( a, DOF, ind, x, r ,n )
      !$OMP PARALLEL DO
      DO i = 1, n; r(i) = b(i) - r(i); END DO
      ! ȍ~qz  z=M^(-1)r ̂
      CALL p_apply_M ( M, DOF, ind, ind_D, r, qz, n  )
      zr   = dot_prod (qz, r, n )
      !$OMP PARALLEL DO
      DO i = 1, n; p(i) = qz(i); END DO

      DO iter = 0, MAX_ITER
         ! ȍ~ qz  q=Ap ̂
         CALL matvec_F77 ( a, DOF, ind,  p, qz, n )
         pq    = dot_prod (p, qz, n )
         alpha = zr / pq
         !$OMP PARALLEL DO
         DO i = 1, n; x(i)  = x(i) + alpha*p(i); END DO
         !$OMP PARALLEL DO
         DO i = 1, n; r(i) = r(i) - alpha*qz(i); END DO
         r_norm = norm (r, n ) ! `FbNKv͂Ȃc
         err    = r_norm / b_norm
         IF ( err < TOL ) EXIT
         IF ( is_first .AND. MOD(iter,MONITOR)==1 ) THEN
            WRITE (*,'("  PCG: Log10(|r|/|b|) =",F7.3," (",I5,"ڔ)")')  LOG10(err), iter
         END IF

         ! ȍ~qz  z=M^(-1)r ̂
         CALL p_apply_M ( M, DOF, ind, ind_D, r, qz, n  )
         zr_new = dot_prod (qz, r, n )
         beta   = zr_new / zr
         zr     = zr_new
         !$OMP PARALLEL DO
         DO i = 1, n; p(i)  = qz(i) + beta * p(i); END DO
      END DO

      IF ( iter > MAX_ITER ) &
       & WRITE(*,*) "xFz@(CG)̔񐔂ł͎Ȃ"

   END SUBROUTINE PCG_F77

!
   SUBROUTINE MRTR_F77 (       a,     DOF,     ind,   ind_D,                   &
                       &       M,       b,       x,       n,    iter, is_first )

      !  CRSL`̑as A ɑ΂ Ax=b OtMRTR@ɂ private[`
      !  iasA ͔Ώ̂łĂ悢D A lłꍇCPCG@ł
      !    ɔUĂ܂CMRTR@ł Soft landing 钷Dj
      !
      !  QljoC쐴CMFMRTR@̑Ώ̐lspOɂ
      !            Trans. of JSCES, Paper No.20060007
      !            i{R[h̕ϐ́C̕ɊÂj

      REAL(DP),   INTENT(in   ) :: a  (*)  ! (nnz)
      INTEGER,    INTENT(in   ) :: DOF(*)  ! (nnz)
      INTEGER,    INTENT(in   ) :: ind(n+1)! (n+1)
      INTEGER,    INTENT(in   ) :: ind_D(n)! (n)
      REAL(DP),   INTENT(in   ) :: M  (*)  ! (0, n, or nnz )
      REAL(DP),   INTENT(in   ) :: b  (n)  ! (n)
      REAL(DP),   INTENT(inout) :: x  (n)  ! (n)
      INTEGER,    INTENT(in   ) :: n
      INTEGER,    INTENT(out  ) :: iter    ! 
      LOGICAL,    INTENT(in   ) :: is_first

      INTEGER  :: k, i
      REAL(DP) :: b_norm, r_norm
      REAL(DP) :: rw, vw, yw               ! ϒl
      REAL(DP) :: eta                      ! _k
      REAL(DP) :: zeta, zeta_old           ! _k
      REAL(DP) :: nu                       ! _k
      REAL     :: err

      b_norm = norm (b, n )
      IF ( (b_norm*TOL)**2 <= TINY(0.0_DP) ) THEN  ! I b_norm == 0.0_DP
         iter = 0
         x(:) = 0.0_DP
         RETURN
      END IF

      CALL matvec_F77 ( a, DOF, ind,     x, r,    n  )  ! r'= A x
      !$OMP PARALLEL DO
      DO i = 1, n; r(i) = b(i) - r(i); END DO           ! r = b - r'
      CALL p_apply_M  ( M, DOF, ind, ind_D, r, u, n  )  ! u = M^(-1) r
      !$OMP PARALLEL DO
      DO i = 1, n; y(i) = -r(i); END DO                 ! y = -r
      CALL p_apply_M  ( M, DOF, ind, ind_D, r, u, n  )  ! u = M^(-1) r;
      !$OMP PARALLEL DO
      DO i = 1, n; p(i) = 0.0_DP; END DO                ! ŏl`䂦[
      !$OMP PARALLEL DO
      DO i = 1, n; z(i) = 0.0_DP; END DO                !                V
      zeta = 0.0_DP                                     !                V

      DO iter = 0, MAX_ITER

         r_norm = norm (r, n )

         err    = r_norm / b_norm
         ! WRITE (99,'(ES15.7)') LOG10(err)
         IF ( err < TOL ) EXIT
         IF ( is_first .AND. MOD(iter,MONITOR)==1 ) THEN
            WRITE (*,'("  MRTR: Log10(|r|/|b|) =",F7.3," (",I5,"ڔ)")') LOG10(err), iter
         END IF

         CALL matvec_F77 ( a, DOF, ind,     u, v,    n  )  ! v_k = A u_k
         CALL p_apply_M  ( M, DOF, ind, ind_D, v, w, n  )  ! w_k = M^(-1) v_k
         rw = dot_prod ( r, w, n )                         ! (r_k,w_k) 
         vw = dot_prod ( v, w, n )                         ! (v_k,w_k)
         yw = dot_prod ( y, w, n )                         ! (y_k,w_k)
         zeta_old = zeta

         IF ( iter > 0 ) THEN ! 2ڈȍ~
            zeta =   nu * rw / ( nu * vw - yw**2 )
            eta  = - yw * rw / ( nu * vw - yw**2 )
         ELSE                 ! ̂
            zeta = rw / vw
            eta  = 0.0_DP
         END IF
         nu = zeta * rw

         !$OMP PARALLEL DO
         DO i = 1, n
            p(i) =       u(i) + (zeta_old/zeta*eta) * p(i)
            x(i) =       x(i) +           zeta      * p(i)
            y(i) = eta * y(i) +           zeta      * v(i)
            z(i) = eta * z(i) +           zeta      * w(i)
            u(i) =       u(i) -                       z(i)
            r(i) =       r(i) -                       y(i)
         END DO

      END DO

      IF ( iter > MAX_ITER ) &
       & WRITE(*,*) "xFOQɊÂŏc@(MRTR@)̔񐔂ł͎Ȃ"

   END SUBROUTINE MRTR_F77
!
!*****************************************************************************************
   FUNCTION dot_prod ( a, b, n ) RESULT ( ans )
      ! g֐ DOT_PRODUCT ̎Łi -Qopt-matmul IvVȂ OpenMP񉻂邽߁j
      ! Ӂj̑avZɂ4{xgp
      !       RFόvZ͉Zɂ茋ʂςixቺĵŁC
      !       񉻂ƌvẐтɒl΂DʁCɗv锽񐔂ςD
      !       http://www.cms-initiative.jp/ja/events/others-event/c9pj29/katagiri-handout2
      INTEGER,  INTENT(in   ) :: n
      REAL(DP), INTENT(in   ) :: a(:)  ! ( > n )  zł
      REAL(DP), INTENT(in   ) :: b(:)  !   V          V
      REAL(DP)                :: ans
      INTEGER, PARAMETER :: QP=SELECTED_REAL_KIND(2*PRECISION(0.0_DP)) ! 4x(Quad Precision)
      REAL(QP) :: s, e
      INTEGER  :: i
      ! 4{x̌vZ̓\tgEFAIɍs߁C̑x̓n[hEFAɔׂ1قǗ
      s = 0.0_QP
      !$OMP PARALLEL DO REDUCTION ( + : s ) PRIVATE ( e )
      DO i = 1, n
         e = a(i)*b(i)                 ! vZʁi{xj4{xɕϊ
         s = s + e                     ! xቺh߂ɁC4{xɂđa
      END DO
      ans = s
   END FUNCTION dot_prod

   FUNCTION norm ( a, n ) RESULT ( ans )
      ! vZxǂȂ̂ŁC𕔂̔{̂ɂ͎gpȂƁiŐ؂蔻prj
      INTEGER,  INTENT(in   ) :: n
      REAL(DP), INTENT(in   ) :: a(:)  ! ( > n )  zł
      REAL(DP)                :: ans
      REAL(DP) :: s
      INTEGER  :: i
      s = 0.0_DP
      !$OMP PARALLEL DO REDUCTION ( + : s )
      DO i = 1, n
         s = s + a(i)*a(i)
      END DO
      ans = SQRT(s)        ! s == 0.0_DP ł SQRT͒`łD
   END FUNCTION norm

END MODULE PCG_CRS_module