!***************************************************************************************
!***  uX^bN(stack, I)v  uL[(queue, ҂s) v                        ***
!***                                             gpf[^\FuOobt@v  ***
!***                     gpASYFu[L[(double-ended queue, deque)v ***
!***************************************************************************************
!
! X^bNF o (First In, Last Out;  FILO) ---
!            j~₨Mɏɐςݏd˂ꍇCŌɐςݏd˂̂ŏɎgD
!
! L[  F o (First In, First Out; FIFO) ---
!            jsɕԏꍇCŏɕ񂾐lŏ̌𓾂D
!
!********************************************************
!
! [L[i[҂sj   X^bN <-- head              tail --> L[
!                              __ __ __ __ __ v_ __ __ __ __ __ v_ __ __ 
!    Oobt@         |__|__|__|__|__|_i|_x|_x|_j|_x|_x|__|__|__|
!    iƃVb|            0              |   ҂      |     n-1
!      ȂĂj         擪f[^̈ʒu               ""f[^Ăʒu
!    
!    ۂ̋Lʒup ́COTCYn @(modulo)Ƃċ߂Dp = MODULO(i,n)
!
!                    QlFΔuASYƃf[^\vCp41`48, gX
!
MODULE buffer_class

   IMPLICIT none
   PRIVATE

   TYPE, PUBLIC :: buf_c
      PRIVATE
      INTEGER              :: head   ! ɎɎof[^̈ʒuw
      INTEGER              :: n      ! tail = head + n ́CɎɃf[^ʒuw
      INTEGER, ALLOCATABLE :: buf(:) ! (0:nbuf-1)   nbuf@Ƃ Oobt@
   END TYPE                          ! \^ALLOCATABLE F2003

   PUBLIC :: init
   INTERFACE init
      MODULE PROCEDURE init_buf
   END INTERFACE

   PUBLIC :: final
   INTERFACE final
      MODULE PROCEDURE final_buf
   END INTERFACE

   PUBLIC :: push      ! X^bNɐς
   PUBLIC :: enqueue   ! L[i҂sjɓ
   PUBLIC :: retrieve  ! popiX^bNoj dequeueiL[ojp
   PUBLIC :: is_empty

   PUBLIC :: dump      ! f[^Ŝ̓foi
   INTERFACE dump
      MODULE PROCEDURE dump_buf
   END INTERFACE

CONTAINS

   SUBROUTINE init_buf ( this, nbuf )
      TYPE(buf_c), INTENT(inout) :: this
      INTEGER,     INTENT(in   ) :: nbuf  ! obt@TCY
      CALL final_buf( this )              ! tFCZCt
      this%head = 0
      this%n    = 0
      ALLOCATE ( this%buf( 0 : nbuf-1 ) )
   END SUBROUTINE init_buf

   SUBROUTINE final_buf ( this )
      TYPE(buf_c), INTENT(inout) :: this
      IF ( ALLOCATED( this%buf ) ) DEALLOCATE( this%buf )
   END SUBROUTINE final_buf

   SUBROUTINE enlarge_buffer ( this )
      TYPE(buf_c), INTENT(inout) :: this
      INTEGER, ALLOCATABLE :: new(:)
      INTEGER, PARAMETER :: m = 2               ! obt@TCY m {
      INTEGER :: i, nbuf
      nbuf = SIZE(this%buf)
      ALLOCATE ( new( 0 : m*nbuf-1 ) )
      DO i = this%head, this%head + nbuf -1     ! f[^ new Ɉڂւ
         new( MODULO(i,m*nbuf) ) = this%buf( MODULO(i,nbuf) )
      END DO
      CALL MOVE_ALLOC( new, this%buf )
      ! F2003KFbufwĂ͉CVnew̎wĂw
   END SUBROUTINE enlarge_buffer

   SUBROUTINE push ( this, c )
      TYPE(buf_c), INTENT(inout) :: this
      INTEGER,     INTENT(in   ) :: c
      INTEGER :: nbuf
      IF ( this%n >= SIZE(this%buf) ) CALL enlarge_buffer( this )
      nbuf  = SIZE(this%buf)
      this%head = MODULO( this%head -1, nbuf )  ! nbuf@ƂāC擪ʒu1OiC
      this%buf( this%head ) = c                 ! f[^ǋL
      this%n = this%n +1
   END SUBROUTINE push

   SUBROUTINE enqueue ( this, c )
      TYPE(buf_c), INTENT(inout) :: this
      INTEGER,     INTENT(in   ) :: c
      INTEGER :: nbuf
      INTEGER :: tail
      IF ( this%n >= SIZE(this%buf) ) CALL enlarge_buffer( this )
      nbuf = SIZE(this%buf)
      tail = MODULO( this%head + this%n, nbuf ) !  nbuf@ƂāC̖ʒuvZC
      this%buf( tail ) = c                      ! f[^ǋL
      this%n = this%n +1
   END SUBROUTINE enqueue

   SUBROUTINE retrieve ( this, c )              ! pop  dequeue p
      TYPE(buf_c), INTENT(inout) :: this
      INTEGER,     INTENT(out  ) :: c
      INTEGER :: nbuf
      IF ( this%n <= 0 ) RETURN
      c = this%buf( this%head )
      nbuf = SIZE(this%buf)
      this%head = MODULO( this%head +1, nbuf )  ! nbuf@ƂāC擪ʒu1
      this%n    = this%n -1
   END SUBROUTINE retrieve

   LOGICAL FUNCTION is_empty ( this )
      TYPE(buf_c), INTENT(in   ) :: this
      is_empty = ( this%n == 0 )
   END FUNCTION is_empty

   SUBROUTINE dump_buf ( this )
      TYPE(buf_c), INTENT(in   ) :: this
      INTEGER :: nbuf
      INTEGER :: i, p
      nbuf = SIZE(this%buf)
      DO i = 0, this%n -1
         p = MODULO( this%head +i, nbuf )
         WRITE(*,'(I8)',advance='no') this%buf(p)
         IF ( MOD(i+1,10) == 0 ) WRITE(*,*) ! s
      END DO
      WRITE(*,*)  ! advance='no' ̂ƂŌɉsKviȂΎ̏o͂Ȃj
   END SUBROUTINE dump_buf

END MODULE buffer_class
