! ********************************************************************************************
! **                  LvfNXie̗p̃AC\pgbN1vfj               **
! ********************************************************************************************
!
! 2pF4ߓ_lӌ`vfio1j (4-node Quadrilateral element, Quad4 Ƃ)
!          -ŎRWnɂ vfߓ_ԍC2x2KEXϕ_ԍ̒`
!
!      (x4,y4)        (x3,y3)      ́FxɑMVDNV[orOTCDp\L xi
!      (-1, 1)      ( 1, 1)      ŁFy          V            C[^orG[^D    V     eta
!          4______|______3         āFz          V            [[^        D    V     zeta
!          |  4   |   3  |         
!          | x    |    x |
!      ____|______|___ __|____ 
!          |  1   |   2  |
!          | x    |    x |
!          |______|______|
!         1       |       2
!      (-1,-1)         ( 1,-1)
!      (x1,y1)         (x2,y2)
!
! 3pF8ߓ_Zʑ̗vfiOd1j (8-node Hexahedral element, Hex8 Ƃj
!          --ĎRWnɂ vfߓ_ԍC2x2x2KEXϕ_ԍ̒`
!
!                     (x8,y8,z8)         (x7,y7,z7)
!                     (-1, 1, 1)         ( 1, 1, 1)
!                          8______________7
!                         /:             /|
!             (x5,y5,z5) / :x         x / |
!             (-1,-1, 1)/  :8         7/  |
!                     5/_____________6/   |
!                     |   x:        x|    |
!                     |   5:x       6|x   |
!                 |    :4........|3...|
!        | /          |   ,4         |   /3
!        |/____     |  ,x         x|  /( 1, 1,-1)
!                     | , 1         2| / (x3,y3,z3)
!                     |,_____________|/
!                     1              2
!             (-1,-1,-1)           ( 1,-1,-1)
!             (x1,y1,z1)           (x2,y2,z2)
!
MODULE element_class

   USE constants
   USE material_class
   IMPLICIT none
   PRIVATE

   ! material_class ɂĒ`ꂽ萔CÔߊmFĂD
   PUBLIC :: ndim                      ! 
   PUBLIC :: nstr                      ! /cݐ (Num of STResses/STRains)

   INTEGER, PARAMETER, PUBLIC  :: nnodee = 2**ndim        ! _ 1-D: 2, 2-D: 4, 3-D: 8
   INTEGER, PARAMETER, PUBLIC  :: nDOFn  = ndim           ! ߓ_DOF (Num of DOFs per Node)
   INTEGER, PARAMETER, PUBLIC  :: nDOFe  = nnodee * nDOFn ! vfDOF         (       V       Elm )
   INTEGER, PARAMETER, PRIVATE :: nGP    = nnodee         ! KEXϕ_    (Num of Gauss Points )

   ! RWnɂ`֐pivZʌŷ߁Cʏ̒`ƏقȂj
   REAL(DP),PARAMETER, PRIVATE :: hf     = 0.5_DP   ! `֐ N()=(1/2+i*) ƒ`邽
   REAL(DP),PARAMETER, PRIVATE :: xi_i(ndim ,nnodee) = RESHAPE ( &  ! `֐p̌W i = }1/2
#ifdef TWO
                                                                 & (/ -hf, -hf, &    ! 1
                                                                    &  hf, -hf, &    ! 2
                                                                    &  hf,  hf, &    ! 3
                                                                    & -hf,  hf /),&  ! 4
#else
                                                                 & (/ -hf, -hf, -hf ,&   ! 1
                                                                    &  hf, -hf, -hf ,&   ! 2
                                                                    &  hf,  hf, -hf ,&   ! :
                                                                    & -hf,  hf, -hf ,&   !
                                                                    & -hf, -hf,  hf ,&   !
                                                                    &  hf, -hf,  hf ,&   !
                                                                    &  hf,  hf,  hf ,&   ! :
                                                                    & -hf,  hf,  hf /),& ! 8
#endif
                                                              & (/ndim ,nnodee/) )

   ! KEXϕ_(Gauss Points)iRWnj! sqrt() ͒萔錾ł͎gpłȂ
   REAL(DP),PARAMETER, PRIVATE :: GP(ndim ,nGP) = xi_i(:,:) * 1.154700538379252_DP
   ! 1.154700538379252 = }(1/2) * 2/sqrt(3.0_DP) = 0.577350269189626

   ! LvfɊւ Abstract Data Type, ADT ̒`
   TYPE, PUBLIC :: elm_c
      PRIVATE
      INTEGER :: matNo              ! ̗vfɑ΂ޗ̈ԍ
      INTEGER :: nodeNo ( nnodee )  ! ̗vf̗vfߓ_ԍS̐ߓ_ԍւ̕ϊTBL
   END TYPE elm_c

   PUBLIC :: init
   INTERFACE init
      ! vfڑS̐ߓ_ԍƍޗ̈ԍ̓Ǎ
      MODULE PROCEDURE read_elm_c
   END INTERFACE

   PUBLIC :: get_nodeNo
   INTERFACE get_nodeNo
      MODULE PROCEDURE get_nodeNo_TBL
   END INTERFACE

   PUBLIC :: get_matNo
   INTERFACE get_matNo
      MODULE PROCEDURE get_matNo_TBL
   END INTERFACE

   PUBLIC :: get_DOFg
   INTERFACE get_DOFg
      ! vfDOFSDOFւ̕ϊTBL̍쐬
      MODULE PROCEDURE get_DOFe2g_TBL
   END INTERFACE

   PUBLIC :: eval_Mass
   INTERFACE eval_Mass
      ! vfʍsԂ
      MODULE PROCEDURE eval_Mass_elm_c
   END INTERFACE

   PUBLIC :: eval_Fin_and_K 
   INTERFACE eval_Fin_and_K
      ! vf̓xNg,vfsԂ
      MODULE PROCEDURE eval_Fin_and_K_elm_c
   END INTERFACE

   PUBLIC :: wrt
   INTERFACE wrt
      ! t@CɌvZʂ
      MODULE PROCEDURE wrt_elm_c
   END INTERFACE

CONTAINS

!************************************************************
   SUBROUTINE read_elm_c ( this, uid, status )
      ! vfڑS̐ߓ_ԍƍޗ̈ԍ̓Ǎ
      TYPE(elm_c),       INTENT(out  ) :: this
      INTEGER,           INTENT(in   ) :: uid    ! t@C̑uԍ
      INTEGER, OPTIONAL, INTENT(out  ) :: status ! I/O ANZX̌
      INTEGER :: stat
      READ ( uid, *, IOSTAT=stat ) this%nodeNo(:), this%matNo
      IF ( PRESENT(status) ) status = stat
   END SUBROUTINE read_elm_c

!************************************************************
   PURE FUNCTION get_nodeNo_TBL ( this ) RESULT ( nodeNo )
      TYPE(elm_c),       INTENT(in   ) :: this
      INTEGER                          :: nodeNo(nnodee)
      nodeNo(:) = this%nodeNo(:)
   END FUNCTION get_nodeNo_TBL

!************************************************************
   PURE FUNCTION get_matNo_TBL ( this ) RESULT ( matNo   )
      TYPE(elm_c),       INTENT(in   ) :: this
      INTEGER                          :: matNo
      matNo = this%matNo
   END FUNCTION get_matNo_TBL

!************************************************************
   PURE FUNCTION get_DOFe2g_TBL ( this, node2DOFg_DB, edge2DOFg_DB ) RESULT ( DOFe2g )

      ! vfRxԍS̎Rxԍւ̕ϊe[uԂ

      TYPE(elm_c),       INTENT(in   ) :: this
      INTEGER,           INTENT(in   ) :: node2DOFg_DB(:,:) ! vfߓ_ԍS̐ߓ_ԍւ̕ϊDB
      INTEGER, OPTIONAL, INTENT(in   ) :: edge2DOFg_DB(:)   ! vfӔԍS̕Ӕԍւ̕ϊDB
      INTEGER                          :: DOFe2g   (nDOFe)  ! vfDOFԍSDOFԍւ̕ϊTBL

      ! vfDOF̕т̒`DʍsC̓xNgCvf̕т͂̒`ɏ]D
      DOFe2g(:) = RESHAPE ( node2DOFg_DB(1:nDOFn, this%nodeNo(:) ), (/nDOFe/) )

   END FUNCTION get_DOFe2g_TBL

!************************************************************
   SUBROUTINE eval_Mass_elm_c ( this, X_DB, mat_DB, Me )
      ! vfʍsԂ
      TYPE(elm_c),          INTENT(in   ) :: this
      REAL(DP),             INTENT(in   ) :: X_DB  (:,:)    ! vfߓ_̍Wl(ndim, nnode)
      TYPE(mat_c),          INTENT(in   ) :: mat_DB(:)      ! eޗɊւ镨lɂĂ̏
      REAL(DP),             INTENT(out  ) :: Me    (nDOFe, nDOFe)  ! vfʍs
      REAL(DP)                            :: Ni             ! `֐
    ! Ni  = ( hf + GP(1,ip)*xi_i(1,i) ) * ( hf + GP(2,ip)*xi_i(2,i) )
      WRITE(*,*) "vfʍs͎Ă܂"
      Me(:,:) = 0.0_DP
   END SUBROUTINE eval_Mass_elm_c

!***********************************
   SUBROUTINE eval_Dump_elm_c( this, X_DB, mat_DB, Ce ) 
      ! vfsԂ
      TYPE(elm_c),          INTENT(in   ) :: this
      REAL(DP),             INTENT(in   ) :: X_DB  (:,:)    ! vfߓ_̍Wl(ndim, nnode)
      TYPE(mat_c),          INTENT(in   ) :: mat_DB(:)      ! eޗɊւ镨lɂĂ̏
      REAL(DP),             INTENT(out  ) :: Ce    (nDOFe, nDOFe)  ! vfs
      WRITE(*,*) 's͎ĂȂD'
      Ce(:,:) = -9.9999_DP
   END SUBROUTINE eval_Dump_elm_c

!************************************************************
   SUBROUTINE update_elm_c ( this, X_DB, mat_DB, Ue )

      TYPE(elm_c),          INTENT(inout) :: this
      REAL(DP),   OPTIONAL, INTENT(in   ) :: X_DB  (:,:)    ! vfߓ_̍Wl(ndim, nnode) 
      TYPE(mat_c),OPTIONAL, INTENT(in   ) :: mat_DB(:)      ! ޗ̈
      REAL(DP),   OPTIONAL, INTENT(in   ) :: Ue    (nDOFe)  ! vfψ

      ! ́CȂėǂDȂ킿CS~[`D

   END SUBROUTINE update_elm_c

!************************************************************
   SUBROUTINE eval_Fin_and_K_elm_c ( this, X_DB, mat_DB, Ue, Fine, Ke )

      ! vfψʃxNgUe ͂CÓIvf̓xNgFine ƗvfڐsKe Ԃ

      TYPE(elm_c),          INTENT(in   ) :: this
      REAL(DP),             INTENT(in   ) :: X_DB  (:,:)    ! vfߓ_̍Wl(ndim, nnode)
      TYPE(mat_c),          INTENT(in   ) :: mat_DB(:)      ! eޗɊւ镨lɂĂ̏
      REAL(DP),             INTENT(in   ) :: Ue    (nDOFe)        ! vfψʁxNg|eV
      REAL(DP),             INTENT(out  ) :: Fine  (nDOFe)        ! vf̓xNg
      REAL(DP),   OPTIONAL, INTENT(out  ) :: Ke    (nDOFe, nDOFe) ! vfs

      REAL(DP) :: Xe    (ndim  ,nnodee)  ! vfߓ_W
      REAL(DP) :: Be    (nstr , nDOFe)   ! ψʁ|cݕϊs
      REAL(DP) :: BeT   (nDOFe, nstr )   ! = Be^T
      REAL(DP) :: stress(nstr )
      REAL(DP) :: strain(nstr )
      REAL(DP) :: cD    (nstr , nstr )   ! eWs
      REAL(DP) :: det_Je                 ! KEXϕ_ɂ郄RrsJe̍s
      integer  :: ip

      Xe(:,:) = X_DB(:,this%nodeNo(:))
      ! KEXϖ@ɂvf̓xNgƗvfڐs]
      Fine(:  ) = 0.0_DP
      Ke  (:,:) = 0.0_DP
      DO ip = 1, nGP     ! KEXϕ_GP(:,ip) ɂ֐l d(w=1)|Z

         CALL eval_Be_and_det_Je ( Xe, GP(:,ip), Be, det_Je )
         strain = MATMUL( Be, Ue )
         BeT    = TRANSPOSE( Be )

         IF ( PRESENT( Ke ) ) THEN
            CALL eval_Fin_and_K ( mat_DB(this%matNo), strain, stress , cD )
            Ke(:,:) = Ke(:,:) + MATMUL( BeT, MATMUL( cD, Be) ) * det_Je ! *w(=1)
         ELSE
            CALL eval_Fin_and_K ( mat_DB(this%matNo), strain, stress      )
         END IF

         Fine(:) = Fine(:) + MATMUL( BeT, stress ) * det_Je !*w(=1)

       ! ! vfߓ_tbNX(׏d)̍쐬 (eϕ_ł̓vfߓ_׏d̑)
       ! DO i = 1, nnodee  ! `֐ɊւẮC}gNX炸vZĂD
       !    Ni  = ( hf + GP(1,ip)*xi_i(1,i) ) * ( hf + GP(2,ip)*xi_i(2,i) )
       !    fe(ndim*i-1:ndim*i ) =   fe(ndim*i-1:ndim*i ) &
       !                                    & + this%bdy_per_A(:) * Ni *det_Je      ! *w(=1)
       ! END DO

      END DO

   END SUBROUTINE eval_Fin_and_K_elm_c

!*********************************************************************
   SUBROUTINE wrt_elm_c ( this, X_DB, mat_DB, Ue ,uid, status )

      ! t@CɌvZʂ

      TYPE(elm_c),          INTENT(in   ) :: this
      REAL(DP),             INTENT(in   ) :: X_DB  (:,:)   ! (ndim, nnode)
      TYPE(mat_c),          INTENT(in   ) :: mat_DB(:)     ! eޗɊւ镨lɂĂ̏
      REAL(DP),             INTENT(in   ) :: Ue    (nDOFe) ! vfψ
      INTEGER,              INTENT(in   ) :: uid           ! t@C̑uԍ
      INTEGER,    OPTIONAL, INTENT(out  ) :: status        ! I/O ANZX̌

      REAL(DP) :: Xe    (ndim  ,nnodee)  ! vfߓ_W
      REAL(DP) :: Be  ( nstr, nDOFe )  ! ψʁ|cݕϊs
      REAL(DP) :: stress (nstr)
      REAL(DP) :: strain (nstr)
      INTEGER  :: stat

      REAL(DP) :: det_Je     ! KEXϕ_ɂ郄RrsJe̍s
      integer  :: ip

      Xe(:,:) = X_DB(:,this%nodeNo(:))
      DO ip = 1, nGP     ! KEXϕ_GP(:,ip)
         CALL eval_Be_and_det_Je ( Xe, GP(:,ip), Be, det_Je )
         strain = MATMUL( Be, Ue )
         CALL eval_Fin_and_K ( mat_DB(this%matNo), strain, stress      )
         strain(ndim+1:nstr) = strain(ndim+1:nstr) * 0.5_DP  ! GiDpɃe\cݐɕϊ
         WRITE( uid, '(22'//FP_FMT//')', IOSTAT=stat ) strain(:), stress(:)
      END DO
      IF ( PRESENT(status) ) status = stat

   END SUBROUTINE wrt_elm_c

!************************************************************
   SUBROUTINE eval_Be_and_det_Je ( Xe, xi, Be, det_Je )

      ! RWn̂_ (,,) (=xi(:)) ɂ
      !  B}gNX(ψʁ|cݕϊs) Rrs Je  det(Je) ]

      REAL(DP), INTENT(in   ) :: Xe    (ndim  ,nnodee)  ! vfߓ_WiWj
      REAL(DP), INTENT(in   ) :: xi    (ndim         )  ! RWn̂_̂̒l (ϕ_)
      REAL(DP), INTENT(out  ) :: Be    (nstr  ,nDOFe )  ! ̓_ɂ B}gNX
      REAL(DP), INTENT(out  ) :: det_Je                 !       V       RrsJe̍s

      REAL(DP)                :: Je    (ndim  ,ndim  )  !       V      Rrs(Jacobian)
      REAL(DP)                :: inv_Je(ndim  ,ndim  )  !       V      RrsJe̋ts
      REAL(DP)                :: dN_xi (ndim  ,nnodee)  ! `֐̎RWnɂ 
      REAL(DP)                :: dN_x  (ndim         )  !     V    Wnɂ
      INTEGER                 :: i, j, k

      ! _ =xi(:) ɂ郄Rrs(Jacobian) [(x,y)/(,)] ̒l]
      Je(:,:) = 0.0_DP
      DO i  = 1, nnodee
#ifdef TWO
         dN_xi(1,i) =     xi_i(1,i)        *(hf+xi_i(2,i)*xi(2)) ! = N/݃  (where i = }1/2)
         dN_xi(2,i) = (hf+xi_i(1,i)*xi(1)) *    xi_i(2,i)        ! = N/݃
#else                                                    
         dN_xi(1,i) =     xi_i(1,i)        *(hf+xi_i(2,i)*xi(2)) *(hf+xi_i(3,i)*xi(3)) ! = N/݃
         dN_xi(2,i) = (hf+xi_i(1,i)*xi(1)) *    xi_i(2,i)        *(hf+xi_i(3,i)*xi(3)) ! = N/݃
         dN_xi(3,i) = (hf+xi_i(1,i)*xi(1)) *(hf+xi_i(2,i)*xi(2)) *    xi_i(3,i)        ! = N/݃
#endif
         DO k = 1, ndim
            DO j = 1, ndim
               Je(j,k) = Je(j,k) + dN_xi(j,i)*Xe(k,i)
            END DO
         END DO
      END DO

      ! Rrs̍s񎮂Ƌts Je^(-1) = [(,)/(x,y)] vZ
#ifdef TWO
      CALL inv_2x2( Je, inv_Je, det_Je )
#else
      CALL inv_3x3( Je, inv_Je, det_Je )
#endif

      ! B}gNX]
      DO i = 1, nnodee
         ! ̘AF{N/(x,y)} = [(,)/(x,y)] {N/(,)}
         dN_x = MATMUL(inv_Je, dN_xi(:,i)) 
#ifdef TWO
         Be(:,ndim*i-1) = (/  dN_x(1),  0.0_DP, dN_x(2) /)
         Be(:,ndim*i  ) = (/   0.0_DP, dN_x(2), dN_x(1) /)
#else
         Be(:,ndim*i-2) = (/ dN_x(1),  0.0_DP,  0.0_DP, dN_x(2),  0.0_DP, dN_x(3) /)
         Be(:,ndim*i-1) = (/  0.0_DP, dN_x(2),  0.0_DP, dN_x(1), dN_x(3),  0.0_DP /)
         Be(:,ndim*i  ) = (/  0.0_DP,  0.0_DP, dN_x(3),  0.0_DP, dN_x(2), dN_x(1) /)
#endif
      END DO

   END SUBROUTINE eval_Be_and_det_Je

!**********************************************************************************
   SUBROUTINE inv_2x2( A, invA, detA )

      ! ɂts̋i2x2sj

      REAL(DP), INTENT(in   ) :: A   (2,2)
      REAL(DP), INTENT(out  ) :: invA(2,2) ! ts
      REAL(DP), INTENT(out  ) :: detA      ! RrA

      REAL(DP) :: div_detA

      detA = A(1,1)*A(2,2) -A(1,2)*A(2,1)
      div_detA  = 1.0_DP/detA
      invA(1,1) =  A(2,2)*div_detA
      invA(2,1) = -A(2,1)*div_detA
      invA(1,2) = -A(1,2)*div_detA
      invA(2,2) =  A(1,1)*div_detA
   END SUBROUTINE inv_2x2


   SUBROUTINE inv_3x3( A, invA, detA )

      ! ɂts̋i3x3sj

      REAL(DP), INTENT(in   ) :: A   (3,3)
      REAL(DP), INTENT(out  ) :: invA(3,3) ! ts
      REAL(DP), INTENT(out  ) :: detA      ! RrA

      REAL(DP) :: div_detA

      detA =  A(1,1)*A(2,2)*A(3,3) +A(2,1)*A(3,2)*A(1,3) +A(3,1)*A(1,2)*A(2,3) & ! TX
           & -A(3,1)*A(2,2)*A(1,3) -A(2,1)*A(1,2)*A(3,3) -A(1,1)*A(3,2)*A(2,3)   ! 
      div_detA  = 1.0_DP/detA
      invA(1,1) = ( A(2,2)*A(3,3) -A(2,3)*A(3,2) ) * div_detA
      invA(2,1) = ( A(2,3)*A(3,1) -A(2,1)*A(3,3) ) * div_detA
      invA(3,1) = ( A(2,1)*A(3,2) -A(2,2)*A(3,1) ) * div_detA
      invA(1,2) = ( A(3,2)*A(1,3) -A(3,3)*A(1,2) ) * div_detA
      invA(2,2) = ( A(3,3)*A(1,1) -A(3,1)*A(1,3) ) * div_detA
      invA(3,2) = ( A(3,1)*A(1,2) -A(3,2)*A(1,1) ) * div_detA
      invA(1,3) = ( A(1,2)*A(2,3) -A(1,3)*A(2,2) ) * div_detA
      invA(2,3) = ( A(1,3)*A(2,1) -A(1,1)*A(2,3) ) * div_detA
      invA(3,3) = ( A(1,1)*A(2,2) -A(1,2)*A(2,1) ) * div_detA

   END SUBROUTINE inv_3x3

END MODULE element_class
