MODULE matvec_CRS_module

   USE constants
   IMPLICIT none

CONTAINS

   SUBROUTINE matvec_F77 ( a, DOF, ind,  x,  y,  n  )

      ! sExNg  y  Ax  i A CRS`j

      INTEGER,  INTENT(in   ) :: DOF(*)  ! (nnz)  (*) ͘Aۏ
      REAL(DP), INTENT(in   ) :: a  (*)  ! (nnz)
      INTEGER,  INTENT(in   ) :: ind(n+1)
      INTEGER,  INTENT(in   ) :: n
      REAL(DP), INTENT(in   ) :: x  (n)
      REAL(DP), INTENT(out  ) :: y  (n)
      INTEGER  :: i, j, p
      REAL(DP) :: s

      !$OMP PARALLEL DO PRIVATE ( s, p, j )
      DO i = 1, n                        ! y(i) = y(i) + a(i,j)*x(j)
         s = 0.0_DP
         DO p = ind(i), ind(i+1)-1
            j = DOF(p)
            s = s + a(p) * x(j)
         END DO
         y(i) = s
         ! LꊇŏƁC
         ! y(i) = DOT_PRODUCT( a    (ind(i):ind(i+1)-1), &
         !                   & x(DOF(ind(i):ind(i+1)-1)) )
         ! ̂悤Ȉꊇł̊ԐڎQƂ́CKꎞz񂪍쐬̂ŕs
      END DO

#ifdef SYM_MTX
    ! OMP񉻂ƂĐ\ቺ̂ŁCŝ܂܂ƂĂ
    DO i = 1, n                     ! OMP? => REDUCTION(+:y)  Ȉꎞz y
       DO p = ind(i)+1, ind(i+1)-1  ! OMP? => [vẐőxቺ
          j = DOF(p)
          y(j) = y(j) + a(p)*x(i)   ! OpɊւ
       END DO
    END DO
#endif

    ! ! ⑫FSYM_MTX: sOȂ΁CȉIc
    ! !      iRFǍݐ䂦ɁCa(:)  DOF(:) ւ̃ANZX񐔂j
    ! y(:) = 0.0_DP
    ! DO i = 1, n
    !    p = ind(i)
    !    j = DOF(p)
    !    s = a(p)*x(j)
    !    DO p = ind(i)+1, ind(i+1)-1
    !       j = DOF(p)
    !       s    = s    + a(p)*x(j)
    !       y(j) = y(j) + a(p)*x(i)
    !    END DO
    !    y(i) = y(i) + s
    ! END DO

   END SUBROUTINE matvec_F77

END MODULE matvec_CRS_module