!****************************************************************************************
!*** asƂ̌vZ    iadj_mtx_c^̃TuNXj                                  ***
!***                 f[^\Fuksi[(Compressed Row Storage, CRS)`v  ***
!***                 ASYFڋ͔                       ***
!****************************************************************************************
!
!  ڋɂ́CPARDISOCu( http://pardiso-project.org/ ) gpD
!
!    {R[hł́CIntel MKL (Math Kernel Library)łgpĂD
!       ERpCIvV"-fpp -DMKL" ǉ
!       EFortran90ɂ̗ mklfBNgȉQ
!            ....\mkl\examples\examples_core_f.zip\solverf\source\pardiso_sym_f90.f90
!       Eڍׂ́uReference Manual for Intel Math Kernel LibraryvQ
!
!    C{ƂAcademic(Free) PARDISO Cugꍇɂ͈ȉɒӂ̂ƁD
!       ELinux + gfortran ɂĂ̂݃oCi݁io^݂̂1NԃCZXj
!       E{R[h CALL pardiso (  ) ̈Ǝ኱ႤȂimFj
!
!  ł́CPARDISÔꕔ݂̈̂CLł悤Ƀ[`݌vD


#ifdef MKL
INCLUDE 'mkl_pardiso.f90'   ! Intel MKL pardiso g߂̃wb_t@Ciintel񋟁j
#endif

!
MODULE sp_mtx_class

   USE constants
   USE sort_and_search_module, ONLY: binary_search
#ifdef MKL
   USE mkl_pardiso                              ! mkl_pardiso.f90 ɒ`
#else
   USE PCG_CRS_module
#endif
   USE matvec_CRS_module
   IMPLICIT none
   PRIVATE
                                                ! this%state ̑JڏԂ
   INTEGER, PARAMETER :: not_yet_solved   = 1,& ! "܂[`solveďoĂȂ"
                       & new_mtx_to_solve = 2,& ! "ׂVK̍s"
                       & solved_the_mtx   = 3   ! "̍sƂ"

   TYPE, PUBLIC :: sp_mtx_c
      PRIVATE
      INTEGER,  POINTER     :: ind(:) => NULL() ! (n  ) adj_mtx_c^ ind w
      INTEGER,  POINTER     :: DOF(:) => NULL() ! (nnz)      V       DOF   V
                                                !       FORALL( p=ind(i):ind(i+1)-1 ) DOF(p)
      REAL(DP), ALLOCATABLE :: a  (:)           ! (nnz) [(Non-Zero)̒li[
      INTEGER               :: state &          ! ԋ@BƂĂ̑JڏԃtOisolvepj
                             & = not_yet_solved
#ifdef MKL
      TYPE(mkl_pardiso_handle) :: pt(64)        ! AhXi[piPARDISO64wj
#else
      TYPE(PCG_M_handle) :: solver_handle
#endif
   END TYPE sp_mtx_c

   PUBLIC :: init
   INTERFACE init
      MODULE PROCEDURE init_mtx_CRS
   END INTERFACE

   PUBLIC :: final
   INTERFACE final
      MODULE PROCEDURE final_mtx_CRS
   END INTERFACE

   PUBLIC :: clear
   INTERFACE clear
      MODULE PROCEDURE clear_mtx_CRS
   END INTERFACE

   PUBLIC :: add_clique
   INTERFACE add_clique
      MODULE PROCEDURE add_clique_mtx_CRS
   END INTERFACE

   PUBLIC :: wrt
   INTERFACE wrt
      MODULE PROCEDURE wrt_mtx_CRS
   END INTERFACE

   PUBLIC :: add
   INTERFACE add
      MODULE PROCEDURE add_mtx_CRS
   END INTERFACE

   PUBLIC :: mul
   INTERFACE mul
      MODULE PROCEDURE mul_mtx_CRS
   END INTERFACE

   PUBLIC :: solve
   INTERFACE solve
      MODULE PROCEDURE solve_mtx_CRS
   END INTERFACE

CONTAINS
!
!*****************************************************************************************
   SUBROUTINE init_mtx_CRS ( this ,adj )

      USE adj_mtx_class

      TYPE(sp_mtx_c),  INTENT(inout) :: this
      TYPE(adj_mtx_c), INTENT(inout) :: adj

      INTEGER :: nnz        ! Num. of Non-Zeros

      CALL final_mtx_CRS( this )                ! tFCZCt

      CALL associate( adj, this%ind, this%DOF ) ! adj_mtx_c^̕ϐadji_ELXgj
      IF (      .NOT. ASSOCIATED(this%ind) &
         & .OR. .NOT. ASSOCIATED(this%DOF) ) THEN
         STOP "init G[Fadj_mtx_c^̕ϐĂȂD"
      END IF
      nnz = SIZE( this%DOF )
      ALLOCATE  ( this%a(nnz) )
      CALL clear_mtx_CRS ( this )

      this%state = not_yet_solved

   END SUBROUTINE init_mtx_CRS

!*****************************************************************************************
   SUBROUTINE final_mtx_CRS ( this )

      TYPE(sp_mtx_c), INTENT(inout) :: this

      INTEGER  :: error
      INTEGER  :: phase
      INTEGER  :: idum(1) 
      REAL(DP) :: rdum(1)

      IF ( this%state /= not_yet_solved ) THEN
#ifdef MKL
         ! PARDISÖĺCsolve_mtx_CRS }jAQƂ̂
         phase = -1                             ! PARDISO: 
         CALL pardiso ( this%pt, idum(1), idum(1), idum(1),&
                      & phase,   idum(1), rdum,    idum,   &
                      & idum,    idum,    idum(1), idum,   &
                      & idum(1), rdum,    rdum,    error   )
         IF (error /= 0) STOP "PARDISOG[ : ̉Ɏs"
#else
         CALL final_PCG_CRS ( this%solver_handle )
#endif
      END IF

      IF ( ASSOCIATED( this%ind ) ) this%ind => NULL()
      IF ( ASSOCIATED( this%DOF ) ) this%DOF => NULL()
      IF ( ALLOCATED ( this%a   ) ) DEALLOCATE( this%a )

      this%state = not_yet_solved

   END SUBROUTINE final_mtx_CRS

!*****************************************************************************************
   SUBROUTINE clear_mtx_CRS ( this, B_, beta_ )

      ! [CB_C_* B_ ̂ꂩ NA
      ! prjI͂ɂāCK22 + C/(t) + M/(t^2) vZ
      ! CALL clear ( K22, M, beta_dt2      )  ! K22        M/(t^2)
      ! CALL add   ( K22, C, beta_gamma_dt )  ! K22  K22 + C/(t)

      TYPE(sp_mtx_c),           INTENT(inout) :: this
      TYPE(sp_mtx_c), OPTIONAL, INTENT(in   ) :: B_
      REAL(DP),       OPTIONAL, INTENT(in   ) :: beta_

      INTEGER :: i

      IF ( PRESENT( B_ ) ) THEN
         IF ( .NOT. ASSOCIATED( this%DOF, B_%DOF ) ) THEN
            STOP "clear G[FقȂa\̍sł͏łȂ"
         END IF
         IF ( PRESENT( beta_ ) ) THEN
            !$OMP PARALLEL DO
            DO i = 1, SIZE(this%a)
               this%a(i) = beta_ * B_%a(i)
            END DO
         ELSE
            !$OMP PARALLEL DO
            DO i = 1, SIZE(this%a)
               this%a(i) =         B_%a(i)
            END DO
         END IF
      ELSE
         !$OMP PARALLEL DO
         DO i = 1, SIZE(this%a)
            this%a(i) = 0.0_DP
         END DO
      END IF

      IF ( this%state /= not_yet_solved ) this%state = new_mtx_to_solve

   END SUBROUTINE clear_mtx_CRS


   SUBROUTINE clear_diag_mtx_CRS ( this, D )

      ! Ίp D(:)ŁCΊp[ŃNA

      TYPE(sp_mtx_c), INTENT(inout) :: this
      REAL(DP),       INTENT(in   ) :: D(:)  ! (nDOF_p) Ίp

      INTEGER :: nDOF_p
      INTEGER :: i, loc, p
      LOGICAL :: exist

      nDOF_p = SIZE(this%ind) -1

      IF ( nDOF_p /= SIZE(D) ) STOP "clear G[Fz̑傫vȂ"

      !$OMP PARALLEL DO
      DO i = 1, SIZE(this%a)
         this%a(i) = 0.0_DP
      END DO

      !$OMP PARALLEL DO
      DO i = 1, nDOF_p
#ifdef SYM_MTX
         p = this%ind(i)
#else
         loc = binary_search( i, this%DOF(this%ind(i):this%ind(i+1)-1), exist )
         IF ( .NOT. exist ) STOP "clear G[FasɑΊpȂ"
         p = this%ind(i) -1 + loc
#endif
         this%a(p) = D(i)
      END DO

      IF ( this%state /= not_yet_solved ) this%state = new_mtx_to_solve

   END SUBROUTINE clear_diag_mtx_CRS

!*****************************************************************************************
   SUBROUTINE add_clique_mtx_CRS ( this, Ke, DOFe2g )

      ! vfDOFԍSDOFԍւ̕ϊe[u DOFe2g(:) ɊÂC
      ! S̑as this  vfs Ke(:,:) Z

      ! 2T(binary_search)ŒTDvZ͋CɂCÔ߂̊mFsD

      TYPE(sp_mtx_c), INTENT(inout) :: this
      REAL(DP),       INTENT(in   ) :: Ke  (:,:)
      INTEGER,        INTENT(in   ) :: DOFe2g(:) ! SIZE(DOFe) <= SIZE(Ke,dim=*)

      INTEGER :: nDOFe   ! vfDOF
      INTEGER :: ie, je  ! vfDOFԍ
      INTEGER :: i,  j   ! SDOFԍ
      INTEGER :: loc, p
      LOGICAL :: exist

      nDOFe = SIZE(DOFe2g)

      IF ( nDOFe > SIZE(Ke,dim=1) .OR. &
         & nDOFe > SIZE(Ke,dim=2)      ) STOP "add_clique: z񐡖@"

      DO ie = 1, nDOFe
         i = DOFe2g(ie)                          ! ]RxĂȂ
         IF ( i > 0 ) THEN
            DO je = 1, nDOFe
               j = DOFe2g(je) 
               ! --- vvZbT SJIS  5C ɑΉĂȂ̂ŗv ---
#ifdef SYM_MTX
               IF ( i <= j ) THEN
#else
               IF ( j >  0 ) THEN
#endif
                  ! S̍s̑(i,j)̊i[ʒup TCY ke(ie,je) Z
                  loc = binary_search( j, this%DOF(this%ind(i):this%ind(i+1)-1), exist )
                  IF ( .NOT. exist ) STOP "add_clique: asɊY̊i[ꏊȂ"
                  p = this%ind(i) -1 + loc
                  this%a(p) = this%a(p) + Ke(ie,je)
               END IF
            END DO
         END IF
      END DO

   END SUBROUTINE add_clique_mtx_CRS

!*****************************************************************************************
   SUBROUTINE wrt_mtx_CRS (this, fl_name )

      ! asthis  Coodinate(COO)` i ija` j ŏo

      TYPE(sp_mtx_c), INTENT(in   ) :: this
      CHARACTER(*),   INTENT(in   ) :: fl_name

      INTEGER :: uid = 30
      INTEGER :: i, j, p, nDOF_p

      OPEN (uid, FILE=fl_name )
      nDOF_p = SIZE(this%ind) -1
      DO i = 1, nDOF_p
         DO p = this%ind(i), this%ind(i+1)-1
            j = this%DOF(p)
            WRITE(uid,'(2I10,ES30.15)') i, j, this%a(p)
         END DO
      END DO
      CLOSE(uid)

      WRITE(*,'("Coodinate(COO)`̑asMATLABŉɂ́C̃R}hF")')
      WRITE(*,'("ija  = load(''",A,"'');")') fl_name
      WRITE(*,'("K_pp = sparse(ija(:,1), ija(:,2), ija(:,3) );")')

   END SUBROUTINE wrt_mtx_CRS

!*****************************************************************************************
   SUBROUTINE add_mtx_CRS ( this, B, beta_ )

      ! this  this + B    this  this +  * B

      TYPE(sp_mtx_c),     INTENT(inout) :: this
      TYPE(sp_mtx_c),     INTENT(inout) :: B
      REAL(DP), OPTIONAL, INTENT(in   ) :: beta_   ! XJl

      INTEGER :: i

      IF ( .NOT. ASSOCIATED( this%DOF, B%DOF ) ) THEN
         STOP "add G[FقȂa\̍s񓯎m𑫂ƂĂ"
      END IF

      IF ( PRESENT( beta_ ) ) THEN
         !$OMP PARALLEL DO
         DO i = 1, SIZE(this%a)
            this%a(i) = this%a(i) + beta_ * B%a(i)
         END DO
      ELSE
         !$OMP PARALLEL DO
         DO i = 1, SIZE(this%a)
            this%a(i) = this%a(i) +         B%a(i)
         END DO
      END IF

   END SUBROUTINE add_mtx_CRS

!*****************************************************************************************
   SUBROUTINE mul_mtx_CRS (this, x, y )

      ! sExNg  y  Ax

      TYPE(sp_mtx_c), INTENT(inout) :: this
      REAL(DP),       INTENT(in   ) :: x(:)
      REAL(DP),       INTENT(out  ) :: y(:)

      INTEGER :: nDOF_p

      nDOF_p = SIZE(this%ind(:)) -1
      IF ( SIZE(x) /= nDOF_p ) STOP "mul G[FA1̎vȂ"

      CALL matvec_F77 ( this%a, this%DOF, this%ind, x, y, nDOF_p )
      ! \̂gƍœKȂ\̂ F77ւ̃obNhA

   END SUBROUTINE mul_mtx_CRS

!*****************************************************************************************
   SUBROUTINE solve_mtx_CRS ( this, b, x )

      ! Ax = b  x ɂĉ

      TYPE(sp_mtx_c), INTENT(inout) :: this
      REAL(DP),       INTENT(inout) :: b(:)  ! (inoutwPardisoR)
      REAL(DP),       INTENT(inout) :: x(:)  ! (          V          )

      INTEGER  :: n, nnz

      ! PardisoɕKvȃp[^
      INTEGER, PARAMETER :: maxfct =  1      ! [U[[ɓɕێ
                                             !   [̃Xp[X\ő̌W
      INTEGER, PARAMETER :: mnum   =  maxfct ! tF[Y̎ۂ̍s

#ifdef SYM_MTX
      INTEGER, PARAMETER :: mtype  =  2      ! ls̏ꍇ
#else
      INTEGER, PARAMETER :: mtype  = 11      ! Ώ̍s̏ꍇ
#endif
         !   1  real and structurally symmetric
         !   2  real and symmetric positive definite
         !  -2  real and symmetric indefinite
         !   3  complex and structurally symmetric 
         !   4  complex and Hermitian positive definite
         !  -4  complex and Hermitian indefinite
         !   6  complex and symmetric
         !  11  real and nonsymmetric
         !  13  complex and nonsymmetric

      INTEGER  :: phase                      ! \o[̎s𐧌
         !  11  Analysis
         !  12  Analysis, numerical factorization
         !  13  Analysis, numerical factorization, solve, iterative refinement
         !  22  Numerical factorization
         !  23  Numerical factorization, solve, iterative refinement
         !  33  Solve, iterative refinement
         !  331 like phase=33, but only forward substitution
         !  332 like phase=33, but only diagonal substitution (if available)
         !  333 like phase=33, but only backward substitution
         !  0   Release internal memory for L and U matrix number mnum
         ! -1   Release all internal memory for all matrices

      INTEGER, PARAMETER :: nrhs   =  1      ! ߂Eӂ̐
      INTEGER  :: iparm(64) = 0              ! pardisõp^i[pz
                                             ! iparm(1)=0 iparm(2:64)̓ftHgl
      INTEGER  :: idummy(1)                  ! _~[ziPermutationprj
      INTEGER  :: msglvl                     ! 1: ɊւóC0: o͂Ȃ
      INTEGER  :: error
      INTEGER  :: iter

      n   = SIZE(this%ind) -1
      nnz = SIZE(this%DOF)
      IF ( SIZE(b)/=n .OR. SIZE(x)/=n ) STOP "solve G[FasƐxNg̎v"

      msglvl =  0                            ! uinit ㏉vԈȊOł͉ʏo͂Ȃ
      IF ( this%state == not_yet_solved ) msglvl = 1

#ifdef MKL
      SELECT CASE ( this%state )
         CASE ( not_yet_solved   )
            this%pt(:)%dummy = 0             ! pardiso: 񂾂K{
            phase  = 13                      ! Pardiso: V{bN(1)狁(3)܂
         CASE ( new_mtx_to_solve )
            phase  = 23                      ! Pardiso: l(2)狁(3)܂
         CASE ( solved_the_mtx   )
            phase  = 33                      ! Pardiso: (3)̂
         CASE default
            STOP "solve: ̏ԂɑJڂ邱Ƃ͂Ȃ"
      END SELECT
      CALL pardiso( this%pt  ,maxfct  ,mnum     ,mtype    ,&
                  & phase    ,n       ,this%a   ,this%ind ,&
                  & this%DOF ,idummy  ,nrhs     ,iparm    ,&
                  & msglvl   ,b       ,x        ,error     )
      IF (error /= 0) CALL pardiso_error_message ( error )
#else
      IF ( this%state == not_yet_solved   ) THEN
         CALL  init_PCG_CRS ( this%solver_handle ,this%a ,this%DOF ,this%ind )
         this%state = new_mtx_to_solve
      END IF
      IF ( this%state == new_mtx_to_solve ) THEN
         CALL set_M_PCG_CRS ( this%solver_handle ,this%a ,this%DOF ,this%ind )
      END IF
      CALL    solve_PCG_CRS ( this%solver_handle ,this%a ,this%DOF ,this%ind , &
                            & msglvl,   b,    x  )
#endif
      this%state = solved_the_mtx

   CONTAINS

      SUBROUTINE pardiso_error_message ( error )
         INTEGER, INTENT(in   ) :: error
         SELECT CASE ( error )
          ! CASE (   0 ); WRITE(*,*) "Pardiso I"
            CASE (  -1 )
               STOP "input inconsistent"
            CASE (  -2 )
               STOP "not enough memory"
            CASE (  -3 )
               STOP "reordering problem"
            CASE (  -4 )
               STOP "zero pivot, numerical factorization or iterative refinement problem"
            CASE (  -5 )
               STOP "unclassified (internal) error"
            CASE (  -6 )
               STOP "reordering failed (nonsymmetric matrix only)"
            CASE (  -7 )
               STOP "diagonal matrix is singular"
            CASE (  -8 )
               STOP "32-bit integer overflow problem"
            CASE (  -9 )
               STOP "not enough memory for Out-Of-Core"
            CASE ( -10 )
               STOP "error opening Out-of-Core files"
            CASE ( -11 )
               STOP "read/write error with OOC files"
            CASE ( -12 )
               STOP "(pardiso_64 only) pardiso_64 called from 32-bit library"
         END SELECT
      END SUBROUTINE pardiso_error_message

   END SUBROUTINE solve_mtx_CRS

END MODULE sp_mtx_class
