! IzƘAXg̔r  ` IEɗv鎞 `

MODULE timer

   IMPLICIT none
   INTEGER, PARAMETER :: I8 = SELECTED_INT_KIND(2*RANGE(0))    ! 
   INTEGER(I8), SAVE  :: cnt_st = 0  ! SYSTEM_CLOCK piVOgj

CONTAINS

   SUBROUTINE tic ( )
      ! oߎ(wall time)v^C}[Zbg
      CALL SYSTEM_CLOCK( cnt_st )
   END SUBROUTINE tic

   FUNCTION toc ( ) RESULT ( wall_time )
      ! oߎ(b)ԂiCPUԂƂ͈Ⴄ̂ŒӁj
      REAL        :: wall_time
      INTEGER(I8) :: cnt_now, cnt_rate, cnt_max
      REAL        :: diff
      CALL SYSTEM_CLOCK( cnt_now, cnt_rate, cnt_max )
      IF ( cnt_st <= cnt_now ) THEN
         diff = cnt_now - cnt_st
      ELSE
         diff = cnt_max - cnt_st + cnt_now
      END IF
      wall_time = diff / cnt_rate
   END FUNCTION toc

END MODULE timer


PROGRAM test_main

   USE timer
   IMPLICIT none

   TYPE list
      INTEGER             :: c
      TYPE(list), POINTER :: next
   END TYPE list

   INTEGER, ALLOCATABLE :: a(:)
   TYPE(list), POINTER  :: root => NULL()
   TYPE(list), POINTER  :: ptr             ! ꎞϐ

   INTEGER :: n
   INTEGER :: i

   INTEGER, PARAMETER :: unit_byte = 4
   REAL :: xMB
   REAL :: etime(2)

   PRINT *, 'tTCY i', HUGE(0),'ȉj'
   READ *, n
   xMB = unit_byte*n / REAL((1024)**2)
   PRINT *, xMB, 'MB'

   ! ************
   PRINT *, "Itz (allocatable array)"
   CALL tic()
   ALLOCATE( a(n) )          ! tɗv鎞Ԃ͂قڃ[
   DO i = 1, n
      a(i) = i               ! ɂقƂǂ̎Ԃ₳
   END DO
   etime(1) = toc()
   PRINT '("   tEɗvԁF",F10.4,"sec (",F5.0,"MB/sec)")',&
                                           & etime(1),     xMB/etime(1)
   CALL tic()
   DEALLOCATE( a )
   PRINT '("   ɗv:           ",F10.4,"sec")', toc()
!
   ! ************
   PRINT *, "AXg (linked list)"
   CALL tic()
   ALLOCATE( root )
   ptr => root
   ptr%c = 1
   DO i = 2, n
      ALLOCATE( ptr%next )   ! tɂقƂǂ̎Ԃ₳
      ptr => ptr%next
      ptr%c = i              ! ɗv鎞Ԃ͂قڃ[
   END DO
   ptr%next => NULL()
   etime(2) = toc()
   PRINT '("   tEɗvԁF",F10.4,"sec (",F5.0,"MB/sec)")',&
                                           & etime(2),     xMB/etime(2)
   CALL tic()
   ptr => root
   DO
      IF ( .NOT. ASSOCIATED(ptr%next) ) EXIT
      root => ptr%next
      DEALLOCATE( ptr )
      ptr => root
   END DO
   DEALLOCATE( root )  ! Ō root 
   ! FASSOCIATE(ptr) .TRUE. ̂܂܁i_OOj
   PRINT '("   ɗv:           ",F10.4,"sec")', toc()

   PRINT '(" xF",F5.0)', etime(2)/etime(1)

END PROGRAM test_main


! tTCY i  2147483647 ȉj
!250000
!  0.9536743     MB
! Itz (allocatable array)
!   tEɗvԁF    0.0000sec (  InfMB/sec)
!   ɗv:               0.0000sec
! AXg (linked list)
!   tEɗvԁF    0.0260sec (  37.MB/sec)
!   ɗv:               0.0170sec
! xF  Inf


! tTCY i  2147483647 ȉj
!2500000
!   9.536743     MB
! Itz (allocatable array)
!   tEɗvԁF    0.0060sec (1589.MB/sec)
!   ɗv:               0.0010sec
! AXg (linked list)
!   tEɗvԁF    0.2680sec (  36.MB/sec)
!   ɗv:               0.1710sec
! xF  45.


! tTCY i  2147483647 ȉj
!25000000
!   95.36743     MB
! Itz (allocatable array)
!   tEɗvԁF    0.0740sec (1289.MB/sec)
!   ɗv:               0.0070sec
! AXg (linked list)
!   tEɗvԁF    2.7720sec (  34.MB/sec)
!   ɗv:               1.8340sec
! xF  37.