module selection_sort

   implicit none

contains

   SUBROUTINE sub_F77 ( buf, n )
   ! `󖾎zł̎󂯓n
      INTEGER, INTENT(inout) :: buf(n)
      INTEGER, INTENT(in   ) :: n
      INTEGER :: i, j
      INTEGER :: m
      INTEGER :: tmp
      DO i = 1, n
         m = i
         DO j = i+1, n
            IF ( buf(m) > buf(j) ) m = j
         END DO
         IF ( m /= i ) THEN
            tmp    = buf(i)
            buf(i) = buf(m)
            buf(m) = tmp
         END IF
      END DO
   END SUBROUTINE sub_F77

   SUBROUTINE sub_F90 ( buf )
   ! `pzł̎󂯓niŔzLqqnj
      INTEGER, INTENT(inout) :: buf(:)
      INTEGER :: n
      INTEGER :: i, j
      INTEGER :: m
      INTEGER :: tmp
      n = SIZE(buf)
      DO i = 1, n
         m = i
         DO j = i+1, n
            IF ( buf(m) > buf(j) ) m = j
         END DO
         IF ( m /= i ) THEN
            tmp    = buf(i)
            buf(i) = buf(m)
            buf(m) = tmp
         END IF
      END DO
   END SUBROUTINE sub_F90

end module selection_sort


module timer

   INTEGER, PARAMETER :: I8 = SELECTED_INT_KIND(2*RANGE(0))    ! 
   INTEGER(I8), SAVE  :: cnt_st = 0  ! SYSTEM_CLOCK piVOgj

contains

   SUBROUTINE tic ( )
      ! oߎ(wall time)v^C}[Zbg
      CALL SYSTEM_CLOCK ( cnt_st )
   END SUBROUTINE tic


   FUNCTION toc ( ) RESULT ( wall_time )
      ! oߎ(b)ԂiCPUԂƂ͈Ⴄ̂ŒӁj
      REAL        :: wall_time
      INTEGER(I8) :: cnt_now, cnt_rate, cnt_max  ! ^Ȃ̂́C0.01bȉ̍xv̂
      REAL        :: diff
      IF ( cnt_st == 0_I8 ) THEN
         WRITE(*,*) "ӁjoߎԌv^C}[Zbg䂦C}CiXoߎԂ߂܂"
         CALL tic ( )
         wall_time = -9.999
         RETURN
      END IF
      CALL SYSTEM_CLOCK ( cnt_now, cnt_rate, cnt_max )
      IF ( cnt_st <= cnt_now ) THEN
         diff = cnt_now - cnt_st
      ELSE
         diff = cnt_max - cnt_st + cnt_now
      END IF
      wall_time = diff / cnt_rate
   END FUNCTION toc
end module timer


program test

use timer
use selection_sort

real, allocatable :: r(:)
integer, allocatable :: b(:)

print *, 'input size'
read *, n

allocate( r(n), b(n) )

call random_number( r )
b = INT(10000*r)

call tic
call sub_F77( b, n )
print "(A,F10.5)", '`󖾎z', toc()

b = INT(10000*r)
call tic
call sub_F77( b(n:1:-1), n )    ! ꎞz
print "(A,F10.5)", '`󖾎z b(n:1:-1) ', toc()

b = INT(10000*r)
call tic
call sub_F90( b )
print "(A,F10.5)", '`pz b', toc()

b = INT(10000*r)
call tic
call sub_F90( b(:) )
print "(A,F10.5)", '`pz b(:)', toc()

b = INT(10000*r)
call tic
call sub_F90( b(1:n) )
print "(A,F10.5)", '`pz b(1:n)', toc()

b = INT(10000*r)
call tic
call sub_F90( b(n:1:-1) )
print "(A,F10.5)", '`pz b(n:1:-1) ', toc()

b = INT(10000*r)
call tic
call sub_F90( b(2:n:2) )
print "(A,F10.5)", '`pz b(2:n:2)', toc()

end


! O(n^2)ñASY䂦ɁCn2{ɂȂƌvZԂ4{ɂȂD

! -fast 邾ŁC`󖾎zƌ`pziXgCh1̏ꍇj̍͂ȂȂ

!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ifort pass_array_args.f90 -check:arg_temp_created -fast
!Intel(R) Visual Fortran Compiler XE for applications running on IA-32, Version 12.0.0.104 Build 20101006
!Copyright (C) 1985-2010 Intel Corporation.  All rights reserved.
!
!ipo: remark #11001: performing single-file optimizations
!ipo: remark #11006: generating object file C:\Users\gakuji\AppData\Local\Temp\ipo_7036.obj
!Microsoft (R) Incremental Linker Version 9.00.21022.08
!Copyright (C) Microsoft Corporation.  All rights reserved.
!
!-out:pass_array_args.exe
!-subsystem:console
!C:\Users\gakuji\AppData\Local\Temp\ipo_7036.obj
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!10000
!`󖾎z   0.12800
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)    0.13600
!`pz b   0.12800
!`pz b(:)   0.12700
!`pz b(1:n)   0.12700
!`pz b(n:1:-1)    0.17200
!`pz b(2:n:2)   0.03200
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!10000
!`󖾎z   0.12600
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)    0.13200
!`pz b   0.12900
!`pz b(:)   0.12700
!`pz b(1:n)   0.13100
!`pz b(n:1:-1)    0.17000
!`pz b(2:n:2)   0.03200
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!100000
!`󖾎z  12.77300
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)   12.76700
!`pz b  12.79300
!`pz b(:)  12.71600
!`pz b(1:n)  12.89000
!`pz b(n:1:-1)   16.93300
!`pz b(2:n:2)   3.27800
!
!
!$ ifort pass_array_args.f90 -check:arg_temp_created
!Intel(R) Visual Fortran Compiler XE for applications running on IA-32, Version 12.0.0.104 Build 20101006
!Copyright (C) 1985-2010 Intel Corporation.  All rights reserved.
!
!Microsoft (R) Incremental Linker Version 9.00.21022.08
!Copyright (C) Microsoft Corporation.  All rights reserved.
!
!-out:pass_array_args.exe
!-subsystem:console
!pass_array_args.obj
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!1000
!`󖾎z   0.00100
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)    0.00700
!`pz b   0.00100
!`pz b(:)   0.00000
!`pz b(1:n)   0.00100
!`pz b(n:1:-1)    0.00100
!`pz b(2:n:2)   0.00000
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!10000
!`󖾎z   0.04200
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)    0.04900
!`pz b   0.06600
!`pz b(:)   0.06500
!`pz b(1:n)   0.06700
!`pz b(n:1:-1)    0.06800
!`pz b(2:n:2)   0.01700
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!10000
!`󖾎z   0.04200
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)    0.04700
!`pz b   0.06800
!`pz b(:)   0.06700
!`pz b(1:n)   0.06700
!`pz b(n:1:-1)    0.06500
!`pz b(2:n:2)   0.01600
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./pass_array_args.exe
! input size
!100000
!`󖾎z   4.28000
!forrtl: warning (402): fort: (1): In call to SUB_F77, an array temporary was created for argument #1
!
!`󖾎z b(n:1:-1)    4.25100
!`pz b   6.53100
!`pz b(:)   6.55900
!`pz b(1:n)   6.55800
!`pz b(n:1:-1)    6.65400
!`pz b(2:n:2)   1.63700
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ gfortran pass_array_args.f90
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./a.exe
! input size
!10000
!`󖾎z   0.16300
!`󖾎z b(n:1:-1)    0.16500
!`pz b   0.28800
!`pz b(:)   0.28300
!`pz b(1:n)   0.28400
!`pz b(n:1:-1)    0.28200
!`pz b(2:n:2)   0.07000
!
!gakuji@T61 ~/integrated_FEM_src/for_jsces
!$ ./a.exe
! input size
!100000
!`󖾎z  16.33400
!`󖾎z b(n:1:-1)   16.36300
!`pz b  28.64500
!`pz b(:)  28.35600
!`pz b(1:n)  28.54800
!`pz b(n:1:-1)   28.35300
!`pz b(2:n:2)   7.10100
!
!
!
