module timer

   INTEGER, PARAMETER :: I8 = SELECTED_INT_KIND(2*RANGE(0))    ! 
   INTEGER(I8), SAVE  :: cnt_st = 0  ! SYSTEM_CLOCK piVOgj

contains

   SUBROUTINE tic ( )
      ! oߎ(wall time)v^C}[Zbg
      CALL SYSTEM_CLOCK ( cnt_st )
   END SUBROUTINE tic


   FUNCTION toc ( ) RESULT ( wall_time )
      ! oߎ(b)ԂiCPUԂƂ͈Ⴄ̂ŒӁj
      REAL        :: wall_time
      INTEGER(I8) :: cnt_now, cnt_rate, cnt_max  ! ^Ȃ̂́C0.01bȉ̍xv̂
      REAL        :: diff
      IF ( cnt_st == 0_I8 ) THEN
         WRITE(*,*) "ӁjoߎԌv^C}[Zbg䂦C}CiXoߎԂ߂܂"
         CALL tic ( )
         wall_time = -9.999
         RETURN
      END IF
      CALL SYSTEM_CLOCK ( cnt_now, cnt_rate, cnt_max )
      IF ( cnt_st <= cnt_now ) THEN
         diff = cnt_now - cnt_st
      ELSE
         diff = cnt_max - cnt_st + cnt_now
      END IF
      wall_time = diff / cnt_rate
   END FUNCTION toc
end module timer



PROGRAM test_BS_tree_class

   USE  BS_tree_class
   use timer

   INTEGER, PARAMETER :: nDOF = 20
   TYPE :: aa
      TYPE(tree_c), allocatable :: tree(:)   ! X(forest)
   END TYPE

   TYPE (aa) :: a

   INTEGER, ALLOCATABLE :: ndeg(:)

   INTEGER, ALLOCATABLE :: buf(:)
   INTEGER :: max_ndeg, dat
   INTEGER :: i, j, n = 10

   REAL :: r

   allocate ( a%tree(nDOF) )

   call tic()
   !$OMP parallel do private (r,j,dat)
   DO i = 1, nDOF*n
      CALL RANDOM_NUMBER(r)
      j = r*(nDOF-1) +1
      CALL RANDOM_NUMBER(r)
      dat = j*1000 + r*nDOF
      CALL hoge (a%tree(j), dat )
      CALL insert( a%tree(j), dat )
      WRITE(*,*)'',j,'Ԗڂ̖؂ɁC', dat,'o^' 

      CALL display( a%tree(j) )

   END DO
   r = toc(); write(*,*) r
   WRITE(*,*) 'o^̊'

!call tic()
!   ALLOCATE ( buf(n) )
!   buf= 1
!!$OMP parallel do private (j)
!   DO i = 1, nDOF
!      j = nDOF -i +1
!      CALL insert( tree(j), buf, n )
!   END DO
!   WRITE(*,*) 'ꊇo^̊'
!   DEALLOCATE ( buf )
!   r = toc(); write(*,*) r

   ALLOCATE ( ndeg(nDOF) )
   DO i = 1, nDOF
      ndeg(i) = get_ndat( a%tree(i) )
   END DO
   max_ndeg = MAXVAL(ndeg)
!   write(*,*) max_ndeg
   ALLOCATE( buf(max_ndeg) )

call tic()
!$OMP parallel do
   DO i = 1, nDOF
      WRITE(*,*) '',i,'Ԗڂ̖؂̑Sf[^͌v', ndeg(i),'łC'
      CALL get_dat( a%tree(i), buf )
      CALL final( a%tree(i) ) 
      WRITE(*,*) buf(1:ndeg(i))
   END DO
   r = toc(); write(*,*) r

END PROGRAM test_BS_tree_class

subroutine hoge ( tree, dat )
      USE  BS_tree_class
      type(tree_c) :: tree
      integer :: dat
      CALL insert( tree, dat )
end subroutine 
