PROGRAM test_adj_mtx_class

   USE adj_mtx_class
   USE mesh_module
   IMPLICIT none

   TYPE(adj_mtx_c)    :: A_pp             ! S̎Rx̗אڍs
   INTEGER, PARAMETER :: nnode  = 7       ! Sߓ_ (number of nodes)
   INTEGER, PARAMETER :: nelm   = 9       ! Svf (number of elements)
   INTEGER, PARAMETER :: nnodee = 2       ! vf̐ߓ_ (number of nodes per element)
   INTEGER, PARAMETER :: nDOFn  = 1       ! ߓ_̎Rx (number of DOF per node)
   INTEGER, PARAMETER :: nDOF_p = nnode   ! ̔ԍUꂽS̎Rx̑

   INTEGER :: elm2node (nnodee,nelm)      ! vfԍS̐ߓ_ԍւ̕ϊe[u
   INTEGER :: node2DOFg(nDOFn,nDOF_p)     ! S̐ߓ_ԍS̎Rxԍւ̕ϊe[u

   INTEGER, POINTER :: DOF(:) => NULL()   !(nnz     ) CRS`\adj_mtx_c^DOFw
   INTEGER, POINTER :: ind(:) => NULL()   !(nDOF_p+1)            V                 ind   V

   INTEGER :: elm2DOFg (nnodee,nelm)      ! }`J[̂߂̐ڑs̃Xg\
   TYPE(jag), ALLOCATABLE :: col2elm(:)

   INTEGER :: DOFe2g(nnodee)              ! vfRxԍS̎Rxԍւ̕ϊe[u
   INTEGER :: i, k

   elm2node = RESHAPE(  (/ 6, 5, &        ! element No. 1, fe is connected to node No. 6 & 5.
                         & 6, 1, &        !             2, fa
                         & 5, 7, &        !             3, eg
                         & 5, 4, &        !             4, ed
                         & 1, 7, &        !             5, ag
                         & 7, 4, &        !             6, gd
                         & 1, 2, &        !             7, ab
                         & 7, 2, &        !             8, gb
                         & 2, 3  /), &    !             9, bc
                     &  (/ 2, 9  /)  )

   node2DOFg(1,:) = (/1,2,3,4,5,6,7/)     ! K1,2,3,c ƘAԍU 

   PRINT *, 'vf̃}`J['        !i3ځj
   DO k = 1, nelm
      elm2DOFg(:,k) = node2DOFg(1,elm2node(:,k))
   END DO
   CALL mk_col2elm_from_elm2DOFg( col2elm, elm2DOFg )
   DO i = LBOUND(col2elm,DIM=1), UBOUND(col2elm,DIM=1)
      PRINT *, i,':',col2elm(i)%c
   END DO

   ! אڍs̍쐬i2ځj
   CALL init( A_pp, nDOF_p )
   DO k = 1, nelm
      DOFe2g(:) = node2DOFg( 1, elm2node(:,k) )
      CALL add_clique( A_pp, DOFe2g )
   END DO
   CALL wrt( A_pp, 'adj_mtx_org.dat')! אڍso

!   ! S̎Rxԍ̕tւi͔@pRCM@̂݁j
!   CALL renumber( A_pp, node2DOFg )
!   CALL wrt( A_pp, 'adj_mtx_new.dat')! אڍso

   PRINT *, 'אڍsCRS`ƂĎoC̃Xg\\'  !i2ځj
   CALL associate( A_pp, ind, DOF )
   DO i = 1, nDOF_p
      PRINT *, i,':',DOF(ind(i):ind(i+1)-1)
   END DO

END PROGRAM test_adj_mtx_class

! MakefilegȂꍇCWindows Cygwin ɂ *.f90  ifort -c -DSYM_MTX *.f90 Ƃ̂C
! ifort test_adj_mtx_final.f90 mesh_module.obj adj_mtx_class.obj BS_tree_class.obj sort_and_search_module.obj buffer_class.obj

! vf̃}`J[
!           1 :           1           5           9
!           2 :           2           8
!           3 :           3           7
!           4 :           1           6
!
!-->> S̎Rxԍ̕tւRgAEgꍇ
! אڍsCRS`ƂĎoC̃Xg\\
!           1 :           1           2           6           7
!           2 :           2           3           7
!           3 :           3
!           4 :           4           5           7
!           5 :           5           6           7
!           6 :           6
!           7 :           7
!***** CΏ̔Łiwithout -DSYM_MTXj̏ꍇɂ *****
! אڍsCRS`ƂĎoC̃Xg\\
!           1 :           1           2           6           7
!           2 :           1           2           3           7
!           3 :           2           3
!           4 :           4           5           7
!           5 :           4           5           6           7
!           6 :           1           5           6
!           7 :           1           2           4           5           7
!<<-- S̎Rxԍ̕tւRgAEgꍇ


!-->> S̎Rxԍ̕tւꍇ
! אڍsCRS`ƂĎoC̃Xg\\
!           1 :           1           2           3           4
!           2 :           2           4
!           3 :           3           5
!           4 :           4           5           6
!           5 :           5           6
!           6 :           6           7
!           7 :           7
!***** CΏ̔Łiwithout -DSYM_MTXj̏ꍇɂ *****
! אڍsCRS`ƂĎoC̃Xg\\
!           1 :           1           2           3           4
!           2 :           1           2           4
!           3 :           1           3           5
!           4 :           1           2           4           5           6
!           5 :           3           4           5           6
!           6 :           4           5           6           7
!           7 :           6           7
!<<-- S̎Rxԍ̕tւꍇ


!$ cat adj_mtx_org.dat
!     1     1
!     1     2
!     1     6
!     1     7
!     2     1
!     2     2
!     2     3
!     2     7
!     3     2
!     3     3
!     4     4
!     4     5
!     4     7
!     5     4
!     5     5
!     5     6
!     5     7
!     6     1
!     6     5
!     6     6
!     7     1
!     7     2
!     7     4
!     7     5
!     7     7


!-->> S̎Rxԍ̕tւꍇ
!$ cat adj_mtx_new.dat
!     1     1
!     1     2
!     1     3
!     1     4
!     2     1
!     2     2
!     2     4
!     3     1
!     3     3
!     3     5
!     4     1
!     4     2
!     4     4
!     4     5
!     4     6
!     5     3
!     5     4
!     5     5
!     5     6
!     6     4
!     6     5
!     6     6
!     6     7
!     7     6
!     7     7
!<<-- S̎Rxԍ̕tւꍇ
